/*
 * File: TsmInterfaces.h
 * Date: 20 aug 2011
 * Time: 14:07:59
 * Generated by TismTool version 0.7
 */

#ifndef TSM_INTERFACES_H
#define TSM_INTERFACES_H

#include "TsmBase.h"
#include "TsmTrigger.h"
#include "TsmInterfacePort.h"
#include "TsmDefs.h"
using namespace std;
using namespace TsmRTE;

namespace Airco
{

  class IAirco
  {
  public:
    virtual void On() = 0;
    virtual void Off() = 0;
    virtual FanLevel GetLevel() = 0;
    virtual int GetTarget() = 0;
    virtual void SetTarget( int Target ) = 0;
    virtual void Start() = 0;
    virtual void Stop() = 0;
    virtual void FanLow() = 0;
    virtual void FanHigh() = 0;
  };

  class TsmTrigger_IAirco___On : public TsmTrigger
  {
  public:
    TsmTrigger_IAirco___On()
      : TsmTrigger( 1 )
    {
    }
  };

  class TsmTrigger_IAirco___Off : public TsmTrigger
  {
  public:
    TsmTrigger_IAirco___Off()
      : TsmTrigger( 2 )
    {
    }
  };

  class TsmTrigger_IAirco___GetLevel : public TsmTrigger
  {
  public:
    FanLevel _RetVal;

    TsmTrigger_IAirco___GetLevel()
      : TsmTrigger( 3 )
    {
    }
  };

  class TsmTrigger_IAirco___GetTarget : public TsmTrigger
  {
  public:
    int _RetVal;

    TsmTrigger_IAirco___GetTarget()
      : TsmTrigger( 4 )
    {
    }
  };

  class TsmTrigger_IAirco___SetTarget : public TsmTrigger
  {
  public:
    int Target;

    TsmTrigger_IAirco___SetTarget( int Target )
      : TsmTrigger( 5 )
      , Target( Target )
    {
    }
  };

  class TsmTrigger_IAirco___Start : public TsmTrigger
  {
  public:
    TsmTrigger_IAirco___Start()
      : TsmTrigger( 6 )
    {
    }
  };

  class TsmTrigger_IAirco___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IAirco___Stop()
      : TsmTrigger( 7 )
    {
    }
  };

  class TsmTrigger_IAirco___FanLow : public TsmTrigger
  {
  public:
    TsmTrigger_IAirco___FanLow()
      : TsmTrigger( 8 )
    {
    }
  };

  class TsmTrigger_IAirco___FanHigh : public TsmTrigger
  {
  public:
    TsmTrigger_IAirco___FanHigh()
      : TsmTrigger( 9 )
    {
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > IAirco )
  class TsmIPort_IAirco : public TsmInterfacePort, public IAirco
  {
  public:
    TsmIPort_IAirco( TsmBase* oParent )
    {
      TsmName = "IAirco";
      TsmParent = oParent;
    }

    void On()
    {
      bool bDBC;
      TsmTrigger_IAirco___On* tt = new TsmTrigger_IAirco___On;
      TsmRecorder::AddCall( "On", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Off()
    {
      bool bDBC;
      TsmTrigger_IAirco___Off* tt = new TsmTrigger_IAirco___Off;
      TsmRecorder::AddCall( "Off", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    FanLevel GetLevel()
    {
      bool bDBC;
      FanLevel _RetVal;
      TsmTrigger_IAirco___GetLevel* tt = new TsmTrigger_IAirco___GetLevel;
      TsmRecorder::AddCall( "GetLevel", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    int GetTarget()
    {
      bool bDBC;
      int _RetVal;
      TsmTrigger_IAirco___GetTarget* tt = new TsmTrigger_IAirco___GetTarget;
      TsmRecorder::AddCall( "GetTarget", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void SetTarget( int Target )
    {
      bool bDBC;
      TsmTrigger_IAirco___SetTarget* tt = new TsmTrigger_IAirco___SetTarget( Target );
      TsmRecorder::AddCall( "SetTarget", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Start()
    {
      bool bDBC;
      TsmTrigger_IAirco___Start* tt = new TsmTrigger_IAirco___Start;
      TsmRecorder::AddCall( "Start", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_IAirco___Stop* tt = new TsmTrigger_IAirco___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void FanLow()
    {
      bool bDBC;
      TsmTrigger_IAirco___FanLow* tt = new TsmTrigger_IAirco___FanLow;
      TsmRecorder::AddCall( "FanLow", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void FanHigh()
    {
      bool bDBC;
      TsmTrigger_IAirco___FanHigh* tt = new TsmTrigger_IAirco___FanHigh;
      TsmRecorder::AddCall( "FanHigh", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class ISensor
  {
  public:
    virtual double GetTemperature() = 0;
    virtual void SignalAbove( int Target ) = 0;
    virtual void SignalBelow( int Target ) = 0;
    virtual void Stop() = 0;
  };

  class TsmTrigger_ISensor___GetTemperature : public TsmTrigger
  {
  public:
    double _RetVal;

    TsmTrigger_ISensor___GetTemperature()
      : TsmTrigger( 13 )
    {
    }
  };

  class TsmTrigger_ISensor___SignalAbove : public TsmTrigger
  {
  public:
    int Target;

    TsmTrigger_ISensor___SignalAbove( int Target )
      : TsmTrigger( 14 )
      , Target( Target )
    {
    }
  };

  class TsmTrigger_ISensor___SignalBelow : public TsmTrigger
  {
  public:
    int Target;

    TsmTrigger_ISensor___SignalBelow( int Target )
      : TsmTrigger( 15 )
      , Target( Target )
    {
    }
  };

  class TsmTrigger_ISensor___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_ISensor___Stop()
      : TsmTrigger( 16 )
    {
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > ISensor )
  class TsmIPort_ISensor : public TsmInterfacePort, public ISensor
  {
  public:
    TsmIPort_ISensor( TsmBase* oParent )
    {
      TsmName = "ISensor";
      TsmParent = oParent;
    }

    double GetTemperature()
    {
      bool bDBC;
      double _RetVal;
      TsmTrigger_ISensor___GetTemperature* tt = new TsmTrigger_ISensor___GetTemperature;
      TsmRecorder::AddCall( "GetTemperature", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void SignalAbove( int Target )
    {
      bool bDBC;
      TsmTrigger_ISensor___SignalAbove* tt = new TsmTrigger_ISensor___SignalAbove( Target );
      TsmRecorder::AddCall( "SignalAbove", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void SignalBelow( int Target )
    {
      bool bDBC;
      TsmTrigger_ISensor___SignalBelow* tt = new TsmTrigger_ISensor___SignalBelow( Target );
      TsmRecorder::AddCall( "SignalBelow", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_ISensor___Stop* tt = new TsmTrigger_ISensor___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class ICbSensor
  {
  public:
    virtual void CbAbove() = 0;
    virtual void CbBelow() = 0;
    virtual void CbStopped() = 0;
  };

  class TsmTrigger_ICbSensor___CbAbove : public TsmTrigger
  {
  public:
    TsmTrigger_ICbSensor___CbAbove()
      : TsmTrigger( 10 )
    {
    }
  };

  class TsmTrigger_ICbSensor___CbBelow : public TsmTrigger
  {
  public:
    TsmTrigger_ICbSensor___CbBelow()
      : TsmTrigger( 11 )
    {
    }
  };

  class TsmTrigger_ICbSensor___CbStopped : public TsmTrigger
  {
  public:
    TsmTrigger_ICbSensor___CbStopped()
      : TsmTrigger( 12 )
    {
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > ICbSensor )
  class TsmIPort_ICbSensor : public TsmInterfacePort, public ICbSensor
  {
  public:
    TsmIPort_ICbSensor( TsmBase* oParent )
    {
      TsmName = "ICbSensor";
      TsmParent = oParent;
    }

    void CbAbove()
    {
      bool bDBC;
      TsmTrigger_ICbSensor___CbAbove* tt = new TsmTrigger_ICbSensor___CbAbove;
      TsmRecorder::AddCall( "CbAbove", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbBelow()
    {
      bool bDBC;
      TsmTrigger_ICbSensor___CbBelow* tt = new TsmTrigger_ICbSensor___CbBelow;
      TsmRecorder::AddCall( "CbBelow", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CbStopped()
    {
      bool bDBC;
      TsmTrigger_ICbSensor___CbStopped* tt = new TsmTrigger_ICbSensor___CbStopped;
      TsmRecorder::AddCall( "CbStopped", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class ICooler
  {
  public:
    virtual void Start() = 0;
    virtual void Stop() = 0;
  };

  class TsmTrigger_ICooler___Start : public TsmTrigger
  {
  public:
    TsmTrigger_ICooler___Start()
      : TsmTrigger( 17 )
    {
    }
  };

  class TsmTrigger_ICooler___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_ICooler___Stop()
      : TsmTrigger( 18 )
    {
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > ICooler )
  class TsmIPort_ICooler : public TsmInterfacePort, public ICooler
  {
  public:
    TsmIPort_ICooler( TsmBase* oParent )
    {
      TsmName = "ICooler";
      TsmParent = oParent;
    }

    void Start()
    {
      bool bDBC;
      TsmTrigger_ICooler___Start* tt = new TsmTrigger_ICooler___Start;
      TsmRecorder::AddCall( "Start", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_ICooler___Stop* tt = new TsmTrigger_ICooler___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class IFan
  {
  public:
    virtual void Stop() = 0;
    virtual void ToLow() = 0;
    virtual void ToHigh() = 0;
  };

  class TsmTrigger_IFan___Stop : public TsmTrigger
  {
  public:
    TsmTrigger_IFan___Stop()
      : TsmTrigger( 19 )
    {
    }
  };

  class TsmTrigger_IFan___ToLow : public TsmTrigger
  {
  public:
    TsmTrigger_IFan___ToLow()
      : TsmTrigger( 20 )
    {
    }
  };

  class TsmTrigger_IFan___ToHigh : public TsmTrigger
  {
  public:
    TsmTrigger_IFan___ToHigh()
      : TsmTrigger( 21 )
    {
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > IFan )
  class TsmIPort_IFan : public TsmInterfacePort, public IFan
  {
  public:
    TsmIPort_IFan( TsmBase* oParent )
    {
      TsmName = "IFan";
      TsmParent = oParent;
    }

    void Stop()
    {
      bool bDBC;
      TsmTrigger_IFan___Stop* tt = new TsmTrigger_IFan___Stop;
      TsmRecorder::AddCall( "Stop", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void ToLow()
    {
      bool bDBC;
      TsmTrigger_IFan___ToLow* tt = new TsmTrigger_IFan___ToLow;
      TsmRecorder::AddCall( "ToLow", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void ToHigh()
    {
      bool bDBC;
      TsmTrigger_IFan___ToHigh* tt = new TsmTrigger_IFan___ToHigh;
      TsmRecorder::AddCall( "ToHigh", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };

  class INvm
  {
  public:
    virtual int GetTarget() = 0;
    virtual void SetTarget( int Target ) = 0;
    virtual FanLevel GetFanLevel() = 0;
    virtual void SetFanLevel( FanLevel Level ) = 0;
  };

  class TsmTrigger_INvm___GetTarget : public TsmTrigger
  {
  public:
    int _RetVal;

    TsmTrigger_INvm___GetTarget()
      : TsmTrigger( 22 )
    {
    }
  };

  class TsmTrigger_INvm___SetTarget : public TsmTrigger
  {
  public:
    int Target;

    TsmTrigger_INvm___SetTarget( int Target )
      : TsmTrigger( 23 )
      , Target( Target )
    {
    }
  };

  class TsmTrigger_INvm___GetFanLevel : public TsmTrigger
  {
  public:
    FanLevel _RetVal;

    TsmTrigger_INvm___GetFanLevel()
      : TsmTrigger( 24 )
    {
    }
  };

  class TsmTrigger_INvm___SetFanLevel : public TsmTrigger
  {
  public:
    FanLevel Level;

    TsmTrigger_INvm___SetFanLevel( FanLevel Level )
      : TsmTrigger( 25 )
      , Level( Level )
    {
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > INvm )
  class TsmIPort_INvm : public TsmInterfacePort, public INvm
  {
  public:
    TsmIPort_INvm( TsmBase* oParent )
    {
      TsmName = "INvm";
      TsmParent = oParent;
    }

    int GetTarget()
    {
      bool bDBC;
      int _RetVal;
      TsmTrigger_INvm___GetTarget* tt = new TsmTrigger_INvm___GetTarget;
      TsmRecorder::AddCall( "GetTarget", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void SetTarget( int Target )
    {
      bool bDBC;
      TsmTrigger_INvm___SetTarget* tt = new TsmTrigger_INvm___SetTarget( Target );
      TsmRecorder::AddCall( "SetTarget", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    FanLevel GetFanLevel()
    {
      bool bDBC;
      FanLevel _RetVal;
      TsmTrigger_INvm___GetFanLevel* tt = new TsmTrigger_INvm___GetFanLevel;
      TsmRecorder::AddCall( "GetFanLevel", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void SetFanLevel( FanLevel Level )
    {
      bool bDBC;
      TsmTrigger_INvm___SetFanLevel* tt = new TsmTrigger_INvm___SetFanLevel( Level );
      TsmRecorder::AddCall( "SetFanLevel", this->Source, this->Messager );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };
}
#endif
