/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmComponent.h
 * version 3
 */
#ifndef TSM_COMPONENT_H
#define TSM_COMPONENT_H

#include "TsmClass.h"
using namespace std;

namespace TsmRTE
{
  class TsmComponent : public TsmClass
  {
  public:
    int             mNrClasses;
    TsmClass**      mClasses;
    int             mNrComponents;
    TsmComponent**  mComponents;

    TsmComponent()
      : mNrClasses( 0 )
      , mNrComponents( 0 )
    {
    }
    virtual ~TsmComponent();

    virtual bool IsActive()
    {
      return false;
    }

    virtual string ThreadId()
    {
      return "";
    }

    virtual void TsmInitialiseAll( void* oObject );
    virtual void TsmConnectAll( void* oObject );
    virtual void TsmPrepareAll( void* oObject );
    virtual void TsmRunAll( void* oObject );
    virtual void TsmHaltAll( void* oObject );
    virtual void TsmCeaseAll( void* oObject );
    virtual void TsmDisconnectAll( void* oObject );
    virtual void TsmTerminateAll( void* oObject );
    virtual void TsmMentionAll( void* oObject );
    virtual void TsmCheckVisitAll();

  protected:
    void DoAssembly( TsmClass* Client, string sRequired, TsmClass* Server, string sProvided );
  };
}
#endif
