/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmBase.h
 * version 3
 */
#ifndef TSMBASE_H
#define TSMBASE_H

#include <string>
#include <typeinfo>
#include "Util.h"
using namespace std;

namespace TsmRTE
{
  class TsmBase
  {
  public:
    TsmBase* TsmParent;
    string   TsmName;

    TsmBase()
    {
      TsmParent = NULL;
      TsmName = "";
    }

    virtual ~TsmBase()
    {
    }

    virtual bool IsTsmSubFsm()
    {
      return false;
    }

    virtual string ClassName()
    {
      return typeid( *this ).name();
    }

    string TotalName()
    {
      string s = "";
      if ( NULL != TsmParent )
      {
        s = TsmParent->TotalName();
        string p = s.substr( s.length() - 1, 1 );
        if ( p != ">" )
        {
          s += " ";
        }
        s += ">";
        if ( ! Util::IsNullOrEmpty( TsmName ) )
        {
          s += " ";
        }
      }

      if ( ( this->TsmParent )
        && ( this->TsmParent->IsTsmSubFsm() ) )
      {
        return s + "{" + TsmName + "}";
      }

      return s + TsmName;
    }

    string FullName()
    {
      return "( " + TotalName() + " )";
    }
  };
}
#endif
