/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmLeaf.h
 * version 2
 */
#ifndef TSM_LEAF_H
#define TSM_LEAF_H

#include "TsmState.h"
#include "TsmHandler.h"
#include "TsmHandlerAction.h"
using namespace std;

namespace TsmRTE
{
  class TsmLeaf : public TsmState
  {
  public:
    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }

    /*
     * Results of oHandler.Action :
     * NOK: no triggers, or triggerless
     * GUARD: trigger, guarded
     * OK: internal transition (even ignored transition)
     * TRANSITION: trigger honoured
     */
    void ExecuteTrigger( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::NOK;
    }
  };
}
#endif
