/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmActivity.h
 * version 1
 */
#ifndef TSM_ACTIVITY_H
#define TSM_ACTIVITY_H

#include "TsmTriggerSem.h"
using namespace std;

namespace TsmRTE
{
  class TsmActivity
  {
  private:
    int             mNrAnnounce;
    int             mNrAbandon;
    TsmTriggerSem   mSem;

  public:
    TsmActivity()
      : mNrAnnounce( 0 )
      , mNrAbandon( 0 )
      , mSem()
    {
    }

    void Wait()
    {
      while ( mNrAnnounce != mNrAbandon )
      {
        mSem.WaitOne();
      }
    }

    void Announce()
    {
      mNrAnnounce++;
    }

    void Abandon()
    {
      mNrAbandon++;
      mSem.Release();
    }
  };
}
#endif
