/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmRzVousSem.h
 * version 2
 */
#ifndef TSM_RZVOUSSEM_H
#define TSM_RZVOUSSEM_H

#include <boost/thread/barrier.hpp>
#include <exception>
#include "TsmRzVousException.h"
using namespace std;

namespace TsmRTE
{
  class TsmRzVousSem
  {
  private:
    boost::barrier* mSem;
    bool            mbRendezVous;

  public:
    TsmRzVousSem()
    {
      mSem = new boost::barrier( 2 );
      mbRendezVous = false;
    }

    virtual ~TsmRzVousSem()
    {
      delete mSem;
    }

    void WaitOne()
    {
      //TsmAssert( ! mbRendezVous );
      mbRendezVous = true;
      try
      {
        mSem->wait();
      }
      catch ( boost::thread_interrupted )
      {
        throw TsmRzVousException();
      }
      mbRendezVous = false;
    }

    void Release()
    {
      //TsmAssert( mbRendezVous );
      mSem->wait();
    }

    void Reset()
    {
      if ( mbRendezVous )
      {
        mbRendezVous = false;
        // Easiest way to reset the semaphore.
        delete mSem;
        mSem = new boost::barrier( 2 );
      }
    }
  };
}
#endif
