/*
 * File: TsmSystem.h
 * Date: 20 aug 2011
 * Time: 14:07:56
 * Generated by TismTool version 0.7
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     10 ( Xmi > Data > Protocols > AircoProtocol > AircoServer > Port )
 *     81 ( Xmi > Data > Protocols > SensorProtocol > SensorClient > Port )
 *    108 ( Xmi > Data > Protocols > SensorProtocol > SensorServer > Port )
 *    141 ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > Port )
 *    162 ( Xmi > Data > Protocols > FanProtocol > FanServer > Port )
 *    197 ( Xmi > Data > Protocols > NvmProtocol > NvmServer > Port )
 *    233 ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > pp_airco )
 *    237 ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_sensor )
 * Triggers:
 *      1 void IAirco___On()
 *      2 void IAirco___Off()
 *      3 FanLevel IAirco___GetLevel()
 *      4 int IAirco___GetTarget()
 *      5 void IAirco___SetTarget( int Target )
 *      6 void IAirco___Start()
 *      7 void IAirco___Stop()
 *      8 void IAirco___FanLow()
 *      9 void IAirco___FanHigh()
 *     10 void ICbSensor___CbAbove()
 *     11 void ICbSensor___CbBelow()
 *     12 void ICbSensor___CbStopped()
 *     13 double ISensor___GetTemperature()
 *     14 void ISensor___SignalAbove( int Target )
 *     15 void ISensor___SignalBelow( int Target )
 *     16 void ISensor___Stop()
 *     17 void ICooler___Start()
 *     18 void ICooler___Stop()
 *     19 void IFan___Stop()
 *     20 void IFan___ToLow()
 *     21 void IFan___ToHigh()
 *     22 int INvm___GetTarget()
 *     23 void INvm___SetTarget( int Target )
 *     24 FanLevel INvm___GetFanLevel()
 *     25 void INvm___SetFanLevel( FanLevel Level )
 * Natives:
 *    -57 ( AircoClientPsm >> Active > Cooler > Outer ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer )
 *        SetTarget( Target );
 *    -59 ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
 *        Start();
 *    -60 ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
 *        Stop();
 *    -61 ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
 *        Target=GetTarget();
 *    -72 ( AircoClientPsm >> Active > Fan > ReportLevel ) ->
 *        ( AircoClientPsm >> Active > Fan > ChoiceState )
 *        Level=GetLevel();
 *    -73 ( AircoClientPsm >> Active > Fan > Low ) ->
 *        ( AircoClientPsm >> Active > Fan > High )
 *        FanHigh();
 *    -74 ( AircoClientPsm >> Active > Fan > High ) ->
 *        ( AircoClientPsm >> Active > Fan > Low )
 *        FanLow();
 *    -77 ( AircoClientPsm >> Standby ) ->
 *        ( AircoClientPsm >> Active )
 *        On();
 *    -78 ( AircoClientPsm >> Active ) ->
 *        ( AircoClientPsm >> Standby )
 *        Off();
 *    -95 ( SensorClientPsm >> Outer >> Inner >> Idle ) ->
 *        ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
 *        SignalAbove( Target );
 *    -97 ( SensorClientPsm >> Outer >> Inner >> Idle ) ->
 *        ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
 *        SignalBelow( Target );
 *   -101 ( SensorClientPsm >> Outer >> Inner ) ->
 *        ( SensorClientPsm >> Outer >> Stopping )
 *        Stop();
 *   -103 ( SensorClientPsm >> Outer ) ->
 *        ( SensorClientPsm >> Outer )
 *        GetTemperature();
 *    123 ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) ->
 *        ( SensorServerPsm >> Outer >> Inner >> Idle )
 *        CbAbove();
 *    125 ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) ->
 *        ( SensorServerPsm >> Outer >> Inner >> Idle )
 *        CbBelow();
 *    129 ( SensorServerPsm >> Outer >> Stopping ) ->
 *        ( SensorServerPsm >> Outer >> Inner )
 *        CbStopped();
 *   -157 ( CoolerClientPsm >> Idle ) ->
 *        ( CoolerClientPsm >> Busy )
 *        Start();
 *   -158 ( CoolerClientPsm >> Busy ) ->
 *        ( CoolerClientPsm >> Idle )
 *        Stop();
 *   -186 ( FanClientPsm >> Busy >> Low ) ->
 *        ( FanClientPsm >> Busy >> High )
 *        ToHigh();
 *   -187 ( FanClientPsm >> Busy >> High ) ->
 *        ( FanClientPsm >> Busy >> Low )
 *        ToLow();
 *   -189 ( FanClientPsm >> Idle ) ->
 *        ( FanClientPsm >> Busy >> Low )
 *        ToLow();
 *   -190 ( FanClientPsm >> Idle ) ->
 *        ( FanClientPsm >> Busy >> High )
 *        ToHigh();
 *   -191 ( FanClientPsm >> Busy ) ->
 *        ( FanClientPsm >> Idle )
 *        Stop();
 */

#ifndef TSM_SYSTEM_H
#define TSM_SYSTEM_H

#include "TsmIncludes.h"
#include "TsmInterfaces.h"
#include "TsmDefs.h"
using namespace std;
using namespace TsmRTE;

namespace Airco
{
  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > StandardProfileL3 )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > StandardProfileL3 )
  class Pac_0001_0002 : public TsmPackage
  {
  public:
    Pac_0001_0002( TsmBase* oParent )
    {
      TsmName = "StandardProfileL3";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > MagicDraw Profile > datatypes )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > MagicDraw Profile > datatypes )
  class Pac_0003_0004 : public TsmPackage
  {
  public:
    Pac_0003_0004( TsmBase* oParent )
    {
      TsmName = "datatypes";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > MagicDraw Profile )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > MagicDraw Profile )
  class Pac_0001_0003 : public TsmPackage
  {
  public:
    Pac_0001_0003( TsmBase* oParent )
    {
      TsmName = "MagicDraw Profile";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > UML Standard Profile > StandardProfileL2 )
   ********************************************************************/

   // ( Xmi > UML Standard Profile > StandardProfileL2 )
  class Pac_0001_0005 : public TsmPackage
  {
  public:
    Pac_0001_0005( TsmBase* oParent )
    {
      TsmName = "StandardProfileL2";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> InitialState )
  class Ini_0012_0013 : public TsmPseudo
  {
  public:
    Ini_0012_0013( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 41, "( AircoServerPsm >> InitialState ) => ( AircoServerPsm >> Standby )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 41: // UP: ( AircoServerPsm >> InitialState ) => ( AircoServerPsm >> Standby )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > InitialState )
  class Ini_0015_0016 : public TsmPseudo
  {
  public:
    Ini_0015_0016( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 27, "( AircoServerPsm >> Active > Cooler > InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27: // UP: ( AircoServerPsm >> Active > Cooler > InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> InitialState )
  class Ini_0018_0019 : public TsmPseudo
  {
  public:
    Ini_0018_0019( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 23, "( AircoServerPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 23: // UP: ( AircoServerPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Idle )
  class Lea_0018_0020 : public TsmLeaf
  {
  public:
    Lea_0018_0020( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 26, "( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) : GetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 24, "( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) : Start" );
    }

    void Tra_0018_0023( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0018_0026( TsmHandler& oHandler );
    void Port___GetTarget( TsmHandler& oHandler );
    void Port___Start( TsmHandler& oHandler );
    void Tra_0018_0025( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 23:
        Tra_0018_0023( oHandler );
        break;
      case 26:
        Tra_0018_0026( oHandler );
        break;
      case 24: // UP: ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Cooling )
        bHigher = true;
        break;
      case 25:
        Tra_0018_0025( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Cooling )
  class Lea_0018_0021 : public TsmLeaf
  {
  public:
    Lea_0018_0021( TsmBase* oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 25, "( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) : Stop" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0018_0024( TsmHandler& oHandler );
    void Port___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 24:
        Tra_0018_0024( oHandler );
        break;
      case 25: // UP: ( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >)
  class Reg_0017_0018 : public TsmRegion
  {
  private:
    Ini_0018_0019* oIni_0018_0019; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> InitialState )
    Lea_0018_0020* oLea_0018_0020; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Idle )
    Lea_0018_0021* oLea_0018_0021; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Cooling )

  public:
    Reg_0017_0018( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0018_0019 = new Ini_0018_0019( this );
      oLea_0018_0020 = new Lea_0018_0020( this );
      oLea_0018_0021 = new Lea_0018_0021( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0018_0019;
      mStates[ 1 ] = oLea_0018_0020;
      mStates[ 2 ] = oLea_0018_0021;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0018_0023( TsmHandler& oHandler );
    void Tra_0018_0024( TsmHandler& oHandler );
    void Tra_0018_0025( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 23:
        Tra_0018_0023( oHandler );
        break;
      case 24:
        Tra_0018_0024( oHandler );
        break;
      case 25:
        Tra_0018_0025( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer )
  class Com_0015_0017 : public TsmCompound
  {
  private:
    Reg_0017_0018* oReg_0017_0018; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >)

  public:
    Com_0015_0017( TsmBase* oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0017_0018 = new Reg_0017_0018( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0017_0018;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 22, "( AircoServerPsm >> Active > Cooler > Outer ) => ( AircoServerPsm >> Active > Cooler > Outer ) : SetTarget" );
    }

    void Tra_0015_0027( TsmHandler& oHandler );
    void Tra_0018_0022( TsmHandler& oHandler );
    void Port___SetTarget( int Target, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27:
        Tra_0015_0027( oHandler );
        break;
      case 22:
        Tra_0018_0022( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler )
  class Reg_0014_0015 : public TsmRegion
  {
  private:
    Ini_0015_0016* oIni_0015_0016; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > InitialState )
    Com_0015_0017* oCom_0015_0017; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer )

  public:
    Reg_0014_0015( TsmBase* oParent )
    {
      TsmName = "Cooler";
      TsmParent = oParent;
      oIni_0015_0016 = new Ini_0015_0016( this );
      oCom_0015_0017 = new Com_0015_0017( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0015_0016;
      mStates[ 1 ] = oCom_0015_0017;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0015_0027( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27:
        Tra_0015_0027( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > InitialState )
  class Ini_0028_0029 : public TsmPseudo
  {
  public:
    Ini_0028_0029( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 36, "( AircoServerPsm >> Active > Fan > InitialState ) => ( AircoServerPsm >> Active > Fan > ReportLevel )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36: // UP: ( AircoServerPsm >> Active > Fan > InitialState ) => ( AircoServerPsm >> Active > Fan > ReportLevel )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ChoiceState )
  class Cho_0028_0030 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0028_0030( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 34, "( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )" );
      mTransitions[ 1 ] = new TsmTransition( 35, "( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0028_0037( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 34: // UP: ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )
        bHigher = true;
        break;
      case 35: // UP: ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )
        bHigher = true;
        break;
      case 37:
        Tra_0028_0037( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > Low )
  class Lea_0028_0031 : public TsmLeaf
  {
  public:
    Lea_0028_0031( TsmBase* oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 38, "( AircoServerPsm >> Active > Fan > Low ) => ( AircoServerPsm >> Active > Fan > High ) : FanHigh" );
    }

    void Tra_0028_0034( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0028_0039( TsmHandler& oHandler );
    void Port___FanHigh( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 34:
        Tra_0028_0034( oHandler );
        break;
      case 39:
        Tra_0028_0039( oHandler );
        break;
      case 38: // UP: ( AircoServerPsm >> Active > Fan > Low ) => ( AircoServerPsm >> Active > Fan > High )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > High )
  class Lea_0028_0032 : public TsmLeaf
  {
  public:
    Lea_0028_0032( TsmBase* oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 39, "( AircoServerPsm >> Active > Fan > High ) => ( AircoServerPsm >> Active > Fan > Low ) : FanLow" );
    }

    void Tra_0028_0035( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___FanLow( TsmHandler& oHandler );
    void Tra_0028_0038( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35:
        Tra_0028_0035( oHandler );
        break;
      case 39: // UP: ( AircoServerPsm >> Active > Fan > High ) => ( AircoServerPsm >> Active > Fan > Low )
        bHigher = true;
        break;
      case 38:
        Tra_0028_0038( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ReportLevel )
  class Lea_0028_0033 : public TsmLeaf
  {
  public:
    Lea_0028_0033( TsmBase* oParent )
    {
      TsmName = "ReportLevel";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 37, "( AircoServerPsm >> Active > Fan > ReportLevel ) => ( AircoServerPsm >> Active > Fan > ChoiceState ) : GetLevel" );
    }

    void Tra_0028_0036( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___GetLevel( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36:
        Tra_0028_0036( oHandler );
        break;
      case 37: // UP: ( AircoServerPsm >> Active > Fan > ReportLevel ) => ( AircoServerPsm >> Active > Fan > ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan )
  class Reg_0014_0028 : public TsmRegion
  {
  private:
    Ini_0028_0029* oIni_0028_0029; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > InitialState )
    Cho_0028_0030* oCho_0028_0030; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ChoiceState )
    Lea_0028_0031* oLea_0028_0031; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > Low )
    Lea_0028_0032* oLea_0028_0032; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > High )
    Lea_0028_0033* oLea_0028_0033; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ReportLevel )

  public:
    Reg_0014_0028( TsmBase* oParent )
    {
      TsmName = "Fan";
      TsmParent = oParent;
      oIni_0028_0029 = new Ini_0028_0029( this );
      oCho_0028_0030 = new Cho_0028_0030( this );
      oLea_0028_0031 = new Lea_0028_0031( this );
      oLea_0028_0032 = new Lea_0028_0032( this );
      oLea_0028_0033 = new Lea_0028_0033( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0028_0029;
      mStates[ 1 ] = oCho_0028_0030;
      mStates[ 2 ] = oLea_0028_0031;
      mStates[ 3 ] = oLea_0028_0032;
      mStates[ 4 ] = oLea_0028_0033;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0028_0036( TsmHandler& oHandler );
    void Tra_0028_0034( TsmHandler& oHandler );
    void Tra_0028_0035( TsmHandler& oHandler );
    void Tra_0028_0037( TsmHandler& oHandler );
    void Tra_0028_0039( TsmHandler& oHandler );
    void Tra_0028_0038( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36:
        Tra_0028_0036( oHandler );
        break;
      case 34:
        Tra_0028_0034( oHandler );
        break;
      case 35:
        Tra_0028_0035( oHandler );
        break;
      case 37:
        Tra_0028_0037( oHandler );
        break;
      case 39:
        Tra_0028_0039( oHandler );
        break;
      case 38:
        Tra_0028_0038( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active )
  class Com_0012_0014 : public TsmCompound
  {
  private:
    Reg_0014_0015* oReg_0014_0015; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler )
    Reg_0014_0028* oReg_0014_0028; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan )

  public:
    Com_0012_0014( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0014_0015 = new Reg_0014_0015( this );
      oReg_0014_0028 = new Reg_0014_0028( this );
      mNrRegions = 2;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0014_0015;
      mRegions[ 1 ] = oReg_0014_0028;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 43, "( AircoServerPsm >> Active ) => ( AircoServerPsm >> Standby ) : Off" );
    }

    void Tra_0012_0042( TsmHandler& oHandler );
    void Port___Off( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 42:
        Tra_0012_0042( oHandler );
        break;
      case 43: // UP: ( AircoServerPsm >> Active ) => ( AircoServerPsm >> Standby )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Standby )
  class Lea_0012_0040 : public TsmLeaf
  {
  public:
    Lea_0012_0040( TsmBase* oParent )
    {
      TsmName = "Standby";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 42, "( AircoServerPsm >> Standby ) => ( AircoServerPsm >> Active ) : On" );
    }

    void Tra_0012_0041( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___On( TsmHandler& oHandler );
    void Tra_0012_0043( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 41:
        Tra_0012_0041( oHandler );
        break;
      case 42: // UP: ( AircoServerPsm >> Standby ) => ( AircoServerPsm >> Active )
        bHigher = true;
        break;
      case 43:
        Tra_0012_0043( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >)
  class Reg_0011_0012 : public TsmRegion
  {
  private:
    Ini_0012_0013* oIni_0012_0013; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> InitialState )
    Com_0012_0014* oCom_0012_0014; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active )
    Lea_0012_0040* oLea_0012_0040; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Standby )

  public:
    Reg_0011_0012( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0012_0013 = new Ini_0012_0013( this );
      oCom_0012_0014 = new Com_0012_0014( this );
      oLea_0012_0040 = new Lea_0012_0040( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0012_0013;
      mStates[ 1 ] = oCom_0012_0014;
      mStates[ 2 ] = oLea_0012_0040;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0012_0041( TsmHandler& oHandler );
    void Tra_0012_0042( TsmHandler& oHandler );
    void Tra_0012_0043( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 10:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 41:
        Tra_0012_0041( oHandler );
        break;
      case 42:
        Tra_0012_0042( oHandler );
        break;
      case 43:
        Tra_0012_0043( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm )
  class Fsm_0009_0011 : public TsmFsm
  {
  private:
    Reg_0011_0012* oReg_0011_0012; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >)

  public:
    Fsm_0009_0011( TsmBase* oParent )
    {
      TsmName = "AircoServerPsm";
      TsmParent = oParent;
      oReg_0011_0012 = new Reg_0011_0012( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0011_0012;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer )
  class Cla_0008_0009 : public TsmProtocolClass
  {
  private:
    Fsm_0009_0011* oFsm_0009_0011; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm )
    TsmIPort_IAirco* TsmPI__Port; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > Port )
    TsmPSPort* mPSMessager;
    int MyTarget;

  public:
    Cla_0008_0009( TsmBase* oParent, string sInstanceName ) : MyTarget(21)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0009_0011 = new Fsm_0009_0011( this );
      TsmPI__Port = new TsmIPort_IAirco( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0009_0011;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > AircoProtocol > AircoServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0009_0011->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    FanLevel Function_1001();
    void Function_1002( TsmHandler& oHandler );
    FanLevel Function_1003();
    void Function_1004( TsmHandler& oHandler );
    int Function_1063();
    void Function_1064( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0008_0009()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> InitialState )
  class Ini_0047_0048 : public TsmPseudo
  {
  public:
    Ini_0047_0048( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 76, "( AircoClientPsm >> InitialState ) => ( AircoClientPsm >> Standby )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 76: // UP: ( AircoClientPsm >> InitialState ) => ( AircoClientPsm >> Standby )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > InitialState )
  class Ini_0050_0051 : public TsmPseudo
  {
  public:
    Ini_0050_0051( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 62, "( AircoClientPsm >> Active > Cooler > InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62: // UP: ( AircoClientPsm >> Active > Cooler > InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> InitialState )
  class Ini_0053_0054 : public TsmPseudo
  {
  public:
    Ini_0053_0054( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 58, "( AircoClientPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 58: // UP: ( AircoClientPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Idle )
  class Lea_0053_0055 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0053_0055( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 59, "( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )" );
      mTransitions[ 1 ] = new TsmTransition( 61, "( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )" );
    }

    void Tra_0053_0058( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0053_0061( TsmHandler& oHandler );
    void Tra_0053_0060( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 59:
          return TsmProspect::OK;
        case 61:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 58:
        Tra_0053_0058( oHandler );
        break;
      case 59: // UP: ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 61:
        Tra_0053_0061( oHandler );
        break;
      case 60:
        Tra_0053_0060( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Cooling )
  class Lea_0053_0056 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0053_0056( TsmBase* oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 60, "( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0053_0059( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 60:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 59:
        Tra_0053_0059( oHandler );
        break;
      case 60: // UP: ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >)
  class Reg_0052_0053 : public TsmRegion
  {
  private:
    Ini_0053_0054* oIni_0053_0054; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> InitialState )
    Lea_0053_0055* oLea_0053_0055; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Idle )
    Lea_0053_0056* oLea_0053_0056; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Cooling )

  public:
    Reg_0052_0053( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0053_0054 = new Ini_0053_0054( this );
      oLea_0053_0055 = new Lea_0053_0055( this );
      oLea_0053_0056 = new Lea_0053_0056( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0053_0054;
      mStates[ 1 ] = oLea_0053_0055;
      mStates[ 2 ] = oLea_0053_0056;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0053_0058( TsmHandler& oHandler );
    void Tra_0053_0059( TsmHandler& oHandler );
    void Tra_0053_0060( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 59:
          return TsmProspect::OK;
        case 61:
          return TsmProspect::OK;
        case 60:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 58:
        Tra_0053_0058( oHandler );
        break;
      case 59:
        Tra_0053_0059( oHandler );
        break;
      case 60:
        Tra_0053_0060( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer )
  class Com_0050_0052 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0052_0053* oReg_0052_0053; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >)

  public:
    Com_0050_0052( TsmBase* oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0052_0053 = new Reg_0052_0053( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0052_0053;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 57, "( AircoClientPsm >> Active > Cooler > Outer ) => ( AircoClientPsm >> Active > Cooler > Outer )" );
    }

    void Tra_0050_0062( TsmHandler& oHandler );
    void Tra_0053_0057( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 57:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62:
        Tra_0050_0062( oHandler );
        break;
      case 57:
        Tra_0053_0057( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler )
  class Reg_0049_0050 : public TsmRegion
  {
  private:
    Ini_0050_0051* oIni_0050_0051; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > InitialState )
    Com_0050_0052* oCom_0050_0052; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer )

  public:
    Reg_0049_0050( TsmBase* oParent )
    {
      TsmName = "Cooler";
      TsmParent = oParent;
      oIni_0050_0051 = new Ini_0050_0051( this );
      oCom_0050_0052 = new Com_0050_0052( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0050_0051;
      mStates[ 1 ] = oCom_0050_0052;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0050_0062( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 57:
          return TsmProspect::OK;
        case 59:
          return TsmProspect::OK;
        case 61:
          return TsmProspect::OK;
        case 60:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 62:
        Tra_0050_0062( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > InitialState )
  class Ini_0063_0064 : public TsmPseudo
  {
  public:
    Ini_0063_0064( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 71, "( AircoClientPsm >> Active > Fan > InitialState ) => ( AircoClientPsm >> Active > Fan > ReportLevel )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71: // UP: ( AircoClientPsm >> Active > Fan > InitialState ) => ( AircoClientPsm >> Active > Fan > ReportLevel )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ChoiceState )
  class Cho_0063_0065 : public TsmPseudo
  {
  public:
    Cho_0063_0065( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 69, "( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > Low )" );
      mTransitions[ 1 ] = new TsmTransition( 70, "( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > High )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0063_0072( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69: // UP: ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > Low )
        bHigher = true;
        break;
      case 70: // UP: ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > High )
        bHigher = true;
        break;
      case 72:
        Tra_0063_0072( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > Low )
  class Lea_0063_0066 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0063_0066( TsmBase* oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 73, "( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )" );
    }

    void Tra_0063_0069( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0063_0074( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 73:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69:
        Tra_0063_0069( oHandler );
        break;
      case 73: // UP: ( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 74:
        Tra_0063_0074( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > High )
  class Lea_0063_0067 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0063_0067( TsmBase* oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 74, "( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )" );
    }

    void Tra_0063_0070( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0063_0073( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 74:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 70:
        Tra_0063_0070( oHandler );
        break;
      case 73:
        Tra_0063_0073( oHandler );
        break;
      case 74: // UP: ( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ReportLevel )
  class Lea_0063_0068 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0063_0068( TsmBase* oParent )
    {
      TsmName = "ReportLevel";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 72, "( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )" );
    }

    void Tra_0063_0071( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 72:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71:
        Tra_0063_0071( oHandler );
        break;
      case 72: // UP: ( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan )
  class Reg_0049_0063 : public TsmRegion
  {
  private:
    Ini_0063_0064* oIni_0063_0064; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > InitialState )
    Cho_0063_0065* oCho_0063_0065; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ChoiceState )
    Lea_0063_0066* oLea_0063_0066; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > Low )
    Lea_0063_0067* oLea_0063_0067; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > High )
    Lea_0063_0068* oLea_0063_0068; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ReportLevel )

  public:
    Reg_0049_0063( TsmBase* oParent )
    {
      TsmName = "Fan";
      TsmParent = oParent;
      oIni_0063_0064 = new Ini_0063_0064( this );
      oCho_0063_0065 = new Cho_0063_0065( this );
      oLea_0063_0066 = new Lea_0063_0066( this );
      oLea_0063_0067 = new Lea_0063_0067( this );
      oLea_0063_0068 = new Lea_0063_0068( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0063_0064;
      mStates[ 1 ] = oCho_0063_0065;
      mStates[ 2 ] = oLea_0063_0066;
      mStates[ 3 ] = oLea_0063_0067;
      mStates[ 4 ] = oLea_0063_0068;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0063_0071( TsmHandler& oHandler );
    void Tra_0063_0069( TsmHandler& oHandler );
    void Tra_0063_0070( TsmHandler& oHandler );
    void Tra_0063_0073( TsmHandler& oHandler );
    void Tra_0063_0074( TsmHandler& oHandler );
    void Tra_0063_0072( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 73:
          return TsmProspect::OK;
        case 74:
          return TsmProspect::OK;
        case 72:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71:
        Tra_0063_0071( oHandler );
        break;
      case 69:
        Tra_0063_0069( oHandler );
        break;
      case 70:
        Tra_0063_0070( oHandler );
        break;
      case 73:
        Tra_0063_0073( oHandler );
        break;
      case 74:
        Tra_0063_0074( oHandler );
        break;
      case 72:
        Tra_0063_0072( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active )
  class Com_0047_0049 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0049_0050* oReg_0049_0050; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler )
    Reg_0049_0063* oReg_0049_0063; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan )

  public:
    Com_0047_0049( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0049_0050 = new Reg_0049_0050( this );
      oReg_0049_0063 = new Reg_0049_0063( this );
      mNrRegions = 2;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0049_0050;
      mRegions[ 1 ] = oReg_0049_0063;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 78, "( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )" );
    }

    void Tra_0047_0077( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 78:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 78: // UP: ( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 77:
        Tra_0047_0077( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Standby )
  class Lea_0047_0075 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0047_0075( TsmBase* oParent )
    {
      TsmName = "Standby";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 77, "( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )" );
    }

    void Tra_0047_0076( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0047_0078( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 77:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 76:
        Tra_0047_0076( oHandler );
        break;
      case 78:
        Tra_0047_0078( oHandler );
        break;
      case 77: // UP: ( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >)
  class Reg_0046_0047 : public TsmRegion
  {
  private:
    Ini_0047_0048* oIni_0047_0048; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> InitialState )
    Com_0047_0049* oCom_0047_0049; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active )
    Lea_0047_0075* oLea_0047_0075; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Standby )

  public:
    Reg_0046_0047( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0047_0048 = new Ini_0047_0048( this );
      oCom_0047_0049 = new Com_0047_0049( this );
      oLea_0047_0075 = new Lea_0047_0075( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0047_0048;
      mStates[ 1 ] = oCom_0047_0049;
      mStates[ 2 ] = oLea_0047_0075;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0047_0076( TsmHandler& oHandler );
    void Tra_0047_0078( TsmHandler& oHandler );
    void Tra_0047_0077( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 78:
          return TsmProspect::OK;
        case 57:
          return TsmProspect::OK;
        case 59:
          return TsmProspect::OK;
        case 61:
          return TsmProspect::OK;
        case 60:
          return TsmProspect::OK;
        case 73:
          return TsmProspect::OK;
        case 74:
          return TsmProspect::OK;
        case 72:
          return TsmProspect::OK;
        case 77:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 76:
        Tra_0047_0076( oHandler );
        break;
      case 78:
        Tra_0047_0078( oHandler );
        break;
      case 77:
        Tra_0047_0077( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm )
  class Fsm_0044_0046 : public TsmFsm
  {
  private:
    Reg_0046_0047* oReg_0046_0047; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >)

  public:
    Fsm_0044_0046( TsmBase* oParent )
    {
      TsmName = "AircoClientPsm";
      TsmParent = oParent;
      oReg_0046_0047 = new Reg_0046_0047( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0046_0047;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient )
  class Cla_0008_0044 : public TsmProtocolClass
  {
  private:
    Fsm_0044_0046* oFsm_0044_0046; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm )
    TsmIPort_IAirco* Port; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > Port )
    FanLevel Level;
    int Target;

  public:
    Cla_0008_0044( TsmBase* oParent, string sInstanceName ) : Target(20)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0044_0046 = new Fsm_0044_0046( this );
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0044_0046;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IAirco*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > AircoProtocol > AircoClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0044_0046->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    bool Guard_1005();
    void Function_1040( TsmHandler& oHandler );
    void Function_1041( TsmHandler& oHandler );
    void Function_1042( TsmHandler& oHandler );
    void Function_1043( TsmHandler& oHandler );
    void Function_1044( TsmHandler& oHandler );
    void Function_1045( TsmHandler& oHandler );
    void Function_1046( TsmHandler& oHandler );
    void Function_1047( TsmHandler& oHandler );
    void Function_1048( TsmHandler& oHandler );
    void TsmPrepare( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > AircoProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > AircoProtocol )
  class Pac_0007_0008 : public TsmPackage
  {
  public:
    Pac_0007_0008( TsmBase* oParent )
    {
      TsmName = "AircoProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> InitialState )
  class Ini_0083_0084 : public TsmPseudo
  {
  public:
    Ini_0083_0084( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 106, "( SensorClientPsm >> InitialState ) => ( SensorClientPsm >> Outer )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 106: // UP: ( SensorClientPsm >> InitialState ) => ( SensorClientPsm >> Outer )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> InitialState )
  class Ini_0086_0087 : public TsmPseudo
  {
  public:
    Ini_0086_0087( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 100, "( SensorClientPsm >> Outer >> InitialState ) => ( SensorClientPsm >> Outer >> Inner )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100: // UP: ( SensorClientPsm >> Outer >> InitialState ) => ( SensorClientPsm >> Outer >> Inner )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> InitialState )
  class Ini_0089_0090 : public TsmPseudo
  {
  public:
    Ini_0089_0090( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 94, "( SensorClientPsm >> Outer >> Inner >> InitialState ) => ( SensorClientPsm >> Outer >> Inner >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 94: // UP: ( SensorClientPsm >> Outer >> Inner >> InitialState ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> Idle )
  class Lea_0089_0091 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0089_0091( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 95, "( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )" );
      mTransitions[ 1 ] = new TsmTransition( 97, "( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )" );
    }

    void Tra_0089_0094( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0089_0096( TsmHandler& oHandler );
    void Tra_0089_0098( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 95:
          return TsmProspect::OK;
        case 97:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 94:
        Tra_0089_0094( oHandler );
        break;
      case 95: // UP: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 97: // UP: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 96:
        Tra_0089_0096( oHandler );
        break;
      case 98:
        Tra_0089_0098( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseAbove )
  class Lea_0089_0092 : public TsmLeaf
  {
  public:
    Lea_0089_0092( TsmBase* oParent )
    {
      TsmName = "SenseAbove";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 96, "( SensorClientPsm >> Outer >> Inner >> SenseAbove ) => ( SensorClientPsm >> Outer >> Inner >> Idle ) : CbAbove" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0089_0095( TsmHandler& oHandler );
    void Port___CbAbove( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 81:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 95:
        Tra_0089_0095( oHandler );
        break;
      case 96: // UP: ( SensorClientPsm >> Outer >> Inner >> SenseAbove ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseBelow )
  class Lea_0089_0093 : public TsmLeaf
  {
  public:
    Lea_0089_0093( TsmBase* oParent )
    {
      TsmName = "SenseBelow";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 98, "( SensorClientPsm >> Outer >> Inner >> SenseBelow ) => ( SensorClientPsm >> Outer >> Inner >> Idle ) : CbBelow" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0089_0097( TsmHandler& oHandler );
    void Port___CbBelow( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 81:
        switch ( Command )
        {
        case 11:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 97:
        Tra_0089_0097( oHandler );
        break;
      case 98: // UP: ( SensorClientPsm >> Outer >> Inner >> SenseBelow ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >)
  class Reg_0088_0089 : public TsmRegion
  {
  private:
    Ini_0089_0090* oIni_0089_0090; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> InitialState )
    Lea_0089_0091* oLea_0089_0091; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> Idle )
    Lea_0089_0092* oLea_0089_0092; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseAbove )
    Lea_0089_0093* oLea_0089_0093; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseBelow )

  public:
    Reg_0088_0089( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0089_0090 = new Ini_0089_0090( this );
      oLea_0089_0091 = new Lea_0089_0091( this );
      oLea_0089_0092 = new Lea_0089_0092( this );
      oLea_0089_0093 = new Lea_0089_0093( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0089_0090;
      mStates[ 1 ] = oLea_0089_0091;
      mStates[ 2 ] = oLea_0089_0092;
      mStates[ 3 ] = oLea_0089_0093;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0089_0094( TsmHandler& oHandler );
    void Tra_0089_0095( TsmHandler& oHandler );
    void Tra_0089_0097( TsmHandler& oHandler );
    void Tra_0089_0096( TsmHandler& oHandler );
    void Tra_0089_0098( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 95:
          return TsmProspect::OK;
        case 97:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 81:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 94:
        Tra_0089_0094( oHandler );
        break;
      case 95:
        Tra_0089_0095( oHandler );
        break;
      case 97:
        Tra_0089_0097( oHandler );
        break;
      case 96:
        Tra_0089_0096( oHandler );
        break;
      case 98:
        Tra_0089_0098( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner )
  class Com_0086_0088 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0088_0089* oReg_0088_0089; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >)

  public:
    Com_0086_0088( TsmBase* oParent )
    {
      TsmName = "Inner";
      TsmParent = oParent;
      oReg_0088_0089 = new Reg_0088_0089( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0088_0089;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 101, "( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )" );
    }

    void Tra_0086_0100( TsmHandler& oHandler );
    void Tra_0086_0102( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 101:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0086_0100( oHandler );
        break;
      case 101: // UP: ( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 102:
        Tra_0086_0102( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Stopping )
  class Lea_0086_0099 : public TsmLeaf
  {
  public:
    Lea_0086_0099( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 104, "( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Stopping ) : CbAbove" );
      mTransitions[ 1 ] = new TsmTransition( 105, "( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Stopping ) : CbBelow" );
      mTransitions[ 2 ] = new TsmTransition( 102, "( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Inner ) : CbStopped" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0086_0101( TsmHandler& oHandler );
    void Tra_0086_0104( TsmHandler& oHandler );
    void Port___CbAbove( TsmHandler& oHandler );
    void Tra_0086_0105( TsmHandler& oHandler );
    void Port___CbBelow( TsmHandler& oHandler );
    void Port___CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 81:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101:
        Tra_0086_0101( oHandler );
        break;
      case 104:
        Tra_0086_0104( oHandler );
        break;
      case 105:
        Tra_0086_0105( oHandler );
        break;
      case 102: // UP: ( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Inner )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >)
  class Reg_0085_0086 : public TsmRegion
  {
  private:
    Ini_0086_0087* oIni_0086_0087; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> InitialState )
    Com_0086_0088* oCom_0086_0088; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner )
    Lea_0086_0099* oLea_0086_0099; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Stopping )

  public:
    Reg_0085_0086( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0086_0087 = new Ini_0086_0087( this );
      oCom_0086_0088 = new Com_0086_0088( this );
      oLea_0086_0099 = new Lea_0086_0099( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0086_0087;
      mStates[ 1 ] = oCom_0086_0088;
      mStates[ 2 ] = oLea_0086_0099;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0086_0100( TsmHandler& oHandler );
    void Tra_0086_0101( TsmHandler& oHandler );
    void Tra_0086_0102( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 101:
          return TsmProspect::OK;
        case 95:
          return TsmProspect::OK;
        case 97:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 81:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0086_0100( oHandler );
        break;
      case 101:
        Tra_0086_0101( oHandler );
        break;
      case 102:
        Tra_0086_0102( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer )
  class Com_0083_0085 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0085_0086* oReg_0085_0086; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >)

  public:
    Com_0083_0085( TsmBase* oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0085_0086 = new Reg_0085_0086( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0085_0086;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 103, "( SensorClientPsm >> Outer ) => ( SensorClientPsm >> Outer )" );
    }

    void Tra_0083_0106( TsmHandler& oHandler );
    void Tra_0086_0103( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 103:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 106:
        Tra_0083_0106( oHandler );
        break;
      case 103:
        Tra_0086_0103( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >)
  class Reg_0082_0083 : public TsmRegion
  {
  private:
    Ini_0083_0084* oIni_0083_0084; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> InitialState )
    Com_0083_0085* oCom_0083_0085; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer )

  public:
    Reg_0082_0083( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0083_0084 = new Ini_0083_0084( this );
      oCom_0083_0085 = new Com_0083_0085( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0083_0084;
      mStates[ 1 ] = oCom_0083_0085;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0083_0106( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 103:
          return TsmProspect::OK;
        case 101:
          return TsmProspect::OK;
        case 95:
          return TsmProspect::OK;
        case 97:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 81:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 106:
        Tra_0083_0106( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm )
  class Fsm_0080_0082 : public TsmFsm
  {
  private:
    Reg_0082_0083* oReg_0082_0083; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >)

  public:
    Fsm_0080_0082( TsmBase* oParent )
    {
      TsmName = "SensorClientPsm";
      TsmParent = oParent;
      oReg_0082_0083 = new Reg_0082_0083( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0082_0083;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient )
  class Cla_0079_0080 : public TsmProtocolClass
  {
  private:
    Fsm_0080_0082* oFsm_0080_0082; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm )
    TsmIPort_ISensor* Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > Port )
    TsmIPort_ICbSensor* TsmPI__Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > Port )
    TsmPCPort* mPCMessager;
    int Target;

  public:
    Cla_0079_0080( TsmBase* oParent, string sInstanceName ) : Target(21)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0080_0082 = new Fsm_0080_0082( this );
      TsmPI__Port = new TsmIPort_ICbSensor( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0080_0082;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ISensor*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0080_0082->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1049( TsmHandler& oHandler );
    void Function_1050( TsmHandler& oHandler );
    void Function_1051( TsmHandler& oHandler );
    void Function_1052( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0079_0080()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> InitialState )
  class Ini_0110_0111 : public TsmPseudo
  {
  public:
    Ini_0110_0111( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 138, "( SensorServerPsm >> InitialState ) => ( SensorServerPsm >> Outer )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 138: // UP: ( SensorServerPsm >> InitialState ) => ( SensorServerPsm >> Outer )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
  class Ini_0113_0114 : public TsmPseudo
  {
  public:
    Ini_0113_0114( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 127, "( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Inner )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 127: // UP: ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Inner )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> InitialState )
  class Ini_0116_0117 : public TsmPseudo
  {
  public:
    Ini_0116_0117( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 121, "( SensorServerPsm >> Outer >> Inner >> InitialState ) => ( SensorServerPsm >> Outer >> Inner >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 121: // UP: ( SensorServerPsm >> Outer >> Inner >> InitialState ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> Idle )
  class Lea_0116_0118 : public TsmLeaf
  {
  public:
    Lea_0116_0118( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 122, "( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) : SignalAbove" );
      mTransitions[ 1 ] = new TsmTransition( 124, "( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) : SignalBelow" );
    }

    void Tra_0116_0121( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0116_0123( TsmHandler& oHandler );
    void Tra_0116_0125( TsmHandler& oHandler );
    void Port___SignalAbove( int Target, TsmHandler& oHandler );
    void Port___SignalBelow( int Target, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 108:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 121:
        Tra_0116_0121( oHandler );
        break;
      case 123:
        Tra_0116_0123( oHandler );
        break;
      case 125:
        Tra_0116_0125( oHandler );
        break;
      case 122: // UP: ( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseAbove )
        bHigher = true;
        break;
      case 124: // UP: ( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseBelow )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseAbove )
  class Lea_0116_0119 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0116_0119( TsmBase* oParent )
    {
      TsmName = "SenseAbove";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 123, "( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0116_0122( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 123:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 123: // UP: ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 122:
        Tra_0116_0122( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseBelow )
  class Lea_0116_0120 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0116_0120( TsmBase* oParent )
    {
      TsmName = "SenseBelow";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 125, "( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0116_0124( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 125:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 125: // UP: ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 124:
        Tra_0116_0124( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >)
  class Reg_0115_0116 : public TsmRegion
  {
  private:
    Ini_0116_0117* oIni_0116_0117; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> InitialState )
    Lea_0116_0118* oLea_0116_0118; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> Idle )
    Lea_0116_0119* oLea_0116_0119; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseAbove )
    Lea_0116_0120* oLea_0116_0120; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseBelow )

  public:
    Reg_0115_0116( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0116_0117 = new Ini_0116_0117( this );
      oLea_0116_0118 = new Lea_0116_0118( this );
      oLea_0116_0119 = new Lea_0116_0119( this );
      oLea_0116_0120 = new Lea_0116_0120( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0116_0117;
      mStates[ 1 ] = oLea_0116_0118;
      mStates[ 2 ] = oLea_0116_0119;
      mStates[ 3 ] = oLea_0116_0120;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0116_0121( TsmHandler& oHandler );
    void Tra_0116_0123( TsmHandler& oHandler );
    void Tra_0116_0125( TsmHandler& oHandler );
    void Tra_0116_0122( TsmHandler& oHandler );
    void Tra_0116_0124( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 123:
          return TsmProspect::OK;
        case 125:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 108:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 121:
        Tra_0116_0121( oHandler );
        break;
      case 123:
        Tra_0116_0123( oHandler );
        break;
      case 125:
        Tra_0116_0125( oHandler );
        break;
      case 122:
        Tra_0116_0122( oHandler );
        break;
      case 124:
        Tra_0116_0124( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner )
  class Com_0113_0115 : public TsmCompound
  {
  private:
    Reg_0115_0116* oReg_0115_0116; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >)

  public:
    Com_0113_0115( TsmBase* oParent )
    {
      TsmName = "Inner";
      TsmParent = oParent;
      oReg_0115_0116 = new Reg_0115_0116( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0115_0116;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 128, "( SensorServerPsm >> Outer >> Inner ) => ( SensorServerPsm >> Outer >> Stopping ) : Stop" );
    }

    void Tra_0113_0127( TsmHandler& oHandler );
    void Tra_0113_0129( TsmHandler& oHandler );
    void Port___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 108:
        switch ( Command )
        {
        case 16:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 127:
        Tra_0113_0127( oHandler );
        break;
      case 129:
        Tra_0113_0129( oHandler );
        break;
      case 128: // UP: ( SensorServerPsm >> Outer >> Inner ) => ( SensorServerPsm >> Outer >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Stopping )
  class Lea_0113_0126 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0113_0126( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 129, "( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0113_0128( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 129:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 129: // UP: ( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 128:
        Tra_0113_0128( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)
  class Reg_0112_0113 : public TsmRegion
  {
  private:
    Ini_0113_0114* oIni_0113_0114; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
    Com_0113_0115* oCom_0113_0115; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner )
    Lea_0113_0126* oLea_0113_0126; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Stopping )

  public:
    Reg_0112_0113( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0113_0114 = new Ini_0113_0114( this );
      oCom_0113_0115 = new Com_0113_0115( this );
      oLea_0113_0126 = new Lea_0113_0126( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0113_0114;
      mStates[ 1 ] = oCom_0113_0115;
      mStates[ 2 ] = oLea_0113_0126;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0113_0127( TsmHandler& oHandler );
    void Tra_0113_0129( TsmHandler& oHandler );
    void Tra_0113_0128( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 123:
          return TsmProspect::OK;
        case 125:
          return TsmProspect::OK;
        case 129:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 108:
        switch ( Command )
        {
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 127:
        Tra_0113_0127( oHandler );
        break;
      case 129:
        Tra_0113_0129( oHandler );
        break;
      case 128:
        Tra_0113_0128( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
  class Ini_0130_0131 : public TsmPseudo
  {
  public:
    Ini_0130_0131( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 134, "( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Get )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 134: // UP: ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Get )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> ChoiceState )
  class Cho_0130_0132 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0130_0132( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 136, "( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )" );
      mTransitions[ 1 ] = new TsmTransition( 137, "( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0130_0135( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 136: // UP: ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
        bHigher = true;
        break;
      case 137: // UP: ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
        bHigher = true;
        break;
      case 135:
        Tra_0130_0135( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Get )
  class Lea_0130_0133 : public TsmLeaf
  {
  public:
    Lea_0130_0133( TsmBase* oParent )
    {
      TsmName = "Get";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 135, "( SensorServerPsm >> Outer >> Get ) => ( SensorServerPsm >> Outer >> ChoiceState ) : GetTemperature" );
    }

    void Tra_0130_0134( TsmHandler& oHandler );
    void Tra_0130_0136( TsmHandler& oHandler );
    void Tra_0130_0137( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___GetTemperature( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 108:
        switch ( Command )
        {
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 134:
        Tra_0130_0134( oHandler );
        break;
      case 136:
        Tra_0130_0136( oHandler );
        break;
      case 137:
        Tra_0130_0137( oHandler );
        break;
      case 135: // UP: ( SensorServerPsm >> Outer >> Get ) => ( SensorServerPsm >> Outer >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)
  class Reg_0112_0130 : public TsmRegion
  {
  private:
    Ini_0130_0131* oIni_0130_0131; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
    Cho_0130_0132* oCho_0130_0132; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> ChoiceState )
    Lea_0130_0133* oLea_0130_0133; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Get )

  public:
    Reg_0112_0130( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0130_0131 = new Ini_0130_0131( this );
      oCho_0130_0132 = new Cho_0130_0132( this );
      oLea_0130_0133 = new Lea_0130_0133( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0130_0131;
      mStates[ 1 ] = oCho_0130_0132;
      mStates[ 2 ] = oLea_0130_0133;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0130_0134( TsmHandler& oHandler );
    void Tra_0130_0136( TsmHandler& oHandler );
    void Tra_0130_0137( TsmHandler& oHandler );
    void Tra_0130_0135( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 108:
        switch ( Command )
        {
        case 13:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 134:
        Tra_0130_0134( oHandler );
        break;
      case 136:
        Tra_0130_0136( oHandler );
        break;
      case 137:
        Tra_0130_0137( oHandler );
        break;
      case 135:
        Tra_0130_0135( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer )
  class Com_0110_0112 : public TsmCompound
  {
  private:
    Reg_0112_0113* oReg_0112_0113; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)
    Reg_0112_0130* oReg_0112_0130; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)

  public:
    Com_0110_0112( TsmBase* oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0112_0113 = new Reg_0112_0113( this );
      oReg_0112_0130 = new Reg_0112_0130( this );
      mNrRegions = 2;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0112_0113;
      mRegions[ 1 ] = oReg_0112_0130;
      mNrTransitions = 0;
    }

    void Tra_0110_0138( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 138:
        Tra_0110_0138( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >)
  class Reg_0109_0110 : public TsmRegion
  {
  private:
    Ini_0110_0111* oIni_0110_0111; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> InitialState )
    Com_0110_0112* oCom_0110_0112; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer )

  public:
    Reg_0109_0110( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0110_0111 = new Ini_0110_0111( this );
      oCom_0110_0112 = new Com_0110_0112( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0110_0111;
      mStates[ 1 ] = oCom_0110_0112;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0110_0138( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 123:
          return TsmProspect::OK;
        case 125:
          return TsmProspect::OK;
        case 129:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 108:
        switch ( Command )
        {
        case 13:
          return TsmProspect::OK;
        case 14:
          return TsmProspect::OK;
        case 15:
          return TsmProspect::OK;
        case 16:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 138:
        Tra_0110_0138( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm )
  class Fsm_0107_0109 : public TsmFsm
  {
  private:
    Reg_0109_0110* oReg_0109_0110; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >)

  public:
    Fsm_0107_0109( TsmBase* oParent )
    {
      TsmName = "SensorServerPsm";
      TsmParent = oParent;
      oReg_0109_0110 = new Reg_0109_0110( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0109_0110;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer )
  class Cla_0079_0107 : public TsmProtocolClass
  {
  private:
    Fsm_0107_0109* oFsm_0107_0109; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm )
    TsmIPort_ISensor* TsmPI__Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > Port )
    TsmIPort_ICbSensor* Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > Port )
    TsmPSPort* mPSMessager;

  public:
    Cla_0079_0107( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0107_0109 = new Fsm_0107_0109( this );
      TsmPI__Port = new TsmIPort_ISensor( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0107_0109;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICbSensor*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0107_0109->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    double Function_1006();
    void Function_1007( TsmHandler& oHandler );
    double Function_1008();
    void Function_1009( TsmHandler& oHandler );
    void Function_1053( TsmHandler& oHandler );
    void Function_1054( TsmHandler& oHandler );
    void Function_1055( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0079_0107()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > SensorProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > SensorProtocol )
  class Pac_0007_0079 : public TsmPackage
  {
  public:
    Pac_0007_0079( TsmBase* oParent )
    {
      TsmName = "SensorProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> InitialState )
  class Ini_0143_0144 : public TsmPseudo
  {
  public:
    Ini_0143_0144( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 149, "( CoolerServerPsm >> InitialState ) => ( CoolerServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 149: // UP: ( CoolerServerPsm >> InitialState ) => ( CoolerServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Idle )
  class Lea_0143_0145 : public TsmLeaf
  {
  public:
    Lea_0143_0145( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 147, "( CoolerServerPsm >> Idle ) => ( CoolerServerPsm >> Busy ) : Start" );
    }

    void Tra_0143_0149( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___Start( TsmHandler& oHandler );
    void Tra_0143_0148( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 141:
        switch ( Command )
        {
        case 17:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 149:
        Tra_0143_0149( oHandler );
        break;
      case 147: // UP: ( CoolerServerPsm >> Idle ) => ( CoolerServerPsm >> Busy )
        bHigher = true;
        break;
      case 148:
        Tra_0143_0148( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Busy )
  class Lea_0143_0146 : public TsmLeaf
  {
  public:
    Lea_0143_0146( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 148, "( CoolerServerPsm >> Busy ) => ( CoolerServerPsm >> Idle ) : Stop" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0143_0147( TsmHandler& oHandler );
    void Port___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 141:
        switch ( Command )
        {
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 147:
        Tra_0143_0147( oHandler );
        break;
      case 148: // UP: ( CoolerServerPsm >> Busy ) => ( CoolerServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >)
  class Reg_0142_0143 : public TsmRegion
  {
  private:
    Ini_0143_0144* oIni_0143_0144; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> InitialState )
    Lea_0143_0145* oLea_0143_0145; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Idle )
    Lea_0143_0146* oLea_0143_0146; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Busy )

  public:
    Reg_0142_0143( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0143_0144 = new Ini_0143_0144( this );
      oLea_0143_0145 = new Lea_0143_0145( this );
      oLea_0143_0146 = new Lea_0143_0146( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0143_0144;
      mStates[ 1 ] = oLea_0143_0145;
      mStates[ 2 ] = oLea_0143_0146;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0143_0149( TsmHandler& oHandler );
    void Tra_0143_0147( TsmHandler& oHandler );
    void Tra_0143_0148( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 141:
        switch ( Command )
        {
        case 17:
          return TsmProspect::OK;
        case 18:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 149:
        Tra_0143_0149( oHandler );
        break;
      case 147:
        Tra_0143_0147( oHandler );
        break;
      case 148:
        Tra_0143_0148( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm )
  class Fsm_0140_0142 : public TsmFsm
  {
  private:
    Reg_0142_0143* oReg_0142_0143; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >)

  public:
    Fsm_0140_0142( TsmBase* oParent )
    {
      TsmName = "CoolerServerPsm";
      TsmParent = oParent;
      oReg_0142_0143 = new Reg_0142_0143( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0142_0143;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer )
  class Cla_0139_0140 : public TsmProtocolClass
  {
  private:
    Fsm_0140_0142* oFsm_0140_0142; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm )
    TsmIPort_ICooler* TsmPI__Port; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > Port )
    TsmPSPort* mPSMessager;

  public:
    Cla_0139_0140( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0140_0142 = new Fsm_0140_0142( this );
      TsmPI__Port = new TsmIPort_ICooler( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0140_0142;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0140_0142->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0139_0140()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> InitialState )
  class Ini_0153_0154 : public TsmPseudo
  {
  public:
    Ini_0153_0154( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 159, "( CoolerClientPsm >> InitialState ) => ( CoolerClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 159: // UP: ( CoolerClientPsm >> InitialState ) => ( CoolerClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Idle )
  class Lea_0153_0155 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0153_0155( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 157, "( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )" );
    }

    void Tra_0153_0159( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0153_0158( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 157:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 159:
        Tra_0153_0159( oHandler );
        break;
      case 157: // UP: ( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 158:
        Tra_0153_0158( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Busy )
  class Lea_0153_0156 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0153_0156( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 158, "( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0153_0157( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 158:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 157:
        Tra_0153_0157( oHandler );
        break;
      case 158: // UP: ( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >)
  class Reg_0152_0153 : public TsmRegion
  {
  private:
    Ini_0153_0154* oIni_0153_0154; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> InitialState )
    Lea_0153_0155* oLea_0153_0155; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Idle )
    Lea_0153_0156* oLea_0153_0156; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Busy )

  public:
    Reg_0152_0153( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0153_0154 = new Ini_0153_0154( this );
      oLea_0153_0155 = new Lea_0153_0155( this );
      oLea_0153_0156 = new Lea_0153_0156( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0153_0154;
      mStates[ 1 ] = oLea_0153_0155;
      mStates[ 2 ] = oLea_0153_0156;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0153_0159( TsmHandler& oHandler );
    void Tra_0153_0157( TsmHandler& oHandler );
    void Tra_0153_0158( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 157:
          return TsmProspect::OK;
        case 158:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 159:
        Tra_0153_0159( oHandler );
        break;
      case 157:
        Tra_0153_0157( oHandler );
        break;
      case 158:
        Tra_0153_0158( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm )
  class Fsm_0150_0152 : public TsmFsm
  {
  private:
    Reg_0152_0153* oReg_0152_0153; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >)

  public:
    Fsm_0150_0152( TsmBase* oParent )
    {
      TsmName = "CoolerClientPsm";
      TsmParent = oParent;
      oReg_0152_0153 = new Reg_0152_0153( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0152_0153;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient )
  class Cla_0139_0150 : public TsmProtocolClass
  {
  private:
    Fsm_0150_0152* oFsm_0150_0152; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm )
    TsmIPort_ICooler* Port; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > Port )

  public:
    Cla_0139_0150( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0150_0152 = new Fsm_0150_0152( this );
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0150_0152;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICooler*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0150_0152->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1056( TsmHandler& oHandler );
    void Function_1057( TsmHandler& oHandler );
    void TsmPrepare( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > CoolerProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > CoolerProtocol )
  class Pac_0007_0139 : public TsmPackage
  {
  public:
    Pac_0007_0139( TsmBase* oParent )
    {
      TsmName = "CoolerProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> InitialState )
  class Ini_0164_0165 : public TsmPseudo
  {
  public:
    Ini_0164_0165( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 176, "( FanServerPsm >> InitialState ) => ( FanServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 176: // UP: ( FanServerPsm >> InitialState ) => ( FanServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> Low )
  class Lea_0167_0168 : public TsmLeaf
  {
  public:
    Lea_0167_0168( TsmBase* oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 170, "( FanServerPsm >> Busy >> Low ) => ( FanServerPsm >> Busy >> High ) : ToHigh" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0167_0171( TsmHandler& oHandler );
    void Tra_0164_0173( TsmHandler& oHandler );
    void Port___ToHigh( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 162:
        switch ( Command )
        {
        case 21:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 171:
        Tra_0167_0171( oHandler );
        break;
      case 173:
        Tra_0164_0173( oHandler );
        break;
      case 170: // UP: ( FanServerPsm >> Busy >> Low ) => ( FanServerPsm >> Busy >> High )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> High )
  class Lea_0167_0169 : public TsmLeaf
  {
  public:
    Lea_0167_0169( TsmBase* oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 171, "( FanServerPsm >> Busy >> High ) => ( FanServerPsm >> Busy >> Low ) : ToLow" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___ToLow( TsmHandler& oHandler );
    void Tra_0167_0170( TsmHandler& oHandler );
    void Tra_0164_0174( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 162:
        switch ( Command )
        {
        case 20:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 171: // UP: ( FanServerPsm >> Busy >> High ) => ( FanServerPsm >> Busy >> Low )
        bHigher = true;
        break;
      case 170:
        Tra_0167_0170( oHandler );
        break;
      case 174:
        Tra_0164_0174( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >)
  class Reg_0166_0167 : public TsmRegion
  {
  private:
    Lea_0167_0168* oLea_0167_0168; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> Low )
    Lea_0167_0169* oLea_0167_0169; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> High )

  public:
    Reg_0166_0167( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0167_0168 = new Lea_0167_0168( this );
      oLea_0167_0169 = new Lea_0167_0169( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oLea_0167_0168;
      mStates[ 1 ] = oLea_0167_0169;
    }

    void Tra_0167_0171( TsmHandler& oHandler );
    void Tra_0164_0173( TsmHandler& oHandler );
    void Tra_0167_0170( TsmHandler& oHandler );
    void Tra_0164_0174( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 162:
        switch ( Command )
        {
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 171:
        Tra_0167_0171( oHandler );
        break;
      case 173:
        Tra_0164_0173( oHandler );
        break;
      case 170:
        Tra_0167_0170( oHandler );
        break;
      case 174:
        Tra_0164_0174( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy )
  class Com_0164_0166 : public TsmCompound
  {
  private:
    Reg_0166_0167* oReg_0166_0167; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >)

  public:
    Com_0164_0166( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_0166_0167 = new Reg_0166_0167( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0166_0167;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 175, "( FanServerPsm >> Busy ) => ( FanServerPsm >> Idle ) : Stop" );
    }

    void Port___Stop( TsmHandler& oHandler );
    void Tra_0164_0173( TsmHandler& oHandler );
    void Tra_0164_0174( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 162:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 175: // UP: ( FanServerPsm >> Busy ) => ( FanServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 173:
        Tra_0164_0173( oHandler );
        break;
      case 174:
        Tra_0164_0174( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Idle )
  class Lea_0164_0172 : public TsmLeaf
  {
  public:
    Lea_0164_0172( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 173, "( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> Low ) : ToLow" );
      mTransitions[ 1 ] = new TsmTransition( 174, "( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> High ) : ToHigh" );
    }

    void Tra_0164_0176( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0164_0175( TsmHandler& oHandler );
    void Port___ToLow( TsmHandler& oHandler );
    void Port___ToHigh( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 162:
        switch ( Command )
        {
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 176:
        Tra_0164_0176( oHandler );
        break;
      case 175:
        Tra_0164_0175( oHandler );
        break;
      case 173: // UP: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> Low )
        bHigher = true;
        break;
      case 174: // UP: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> High )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >)
  class Reg_0163_0164 : public TsmRegion
  {
  private:
    Ini_0164_0165* oIni_0164_0165; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> InitialState )
    Com_0164_0166* oCom_0164_0166; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy )
    Lea_0164_0172* oLea_0164_0172; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Idle )

  public:
    Reg_0163_0164( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0164_0165 = new Ini_0164_0165( this );
      oCom_0164_0166 = new Com_0164_0166( this );
      oLea_0164_0172 = new Lea_0164_0172( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0164_0165;
      mStates[ 1 ] = oCom_0164_0166;
      mStates[ 2 ] = oLea_0164_0172;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0164_0176( TsmHandler& oHandler );
    void Tra_0164_0175( TsmHandler& oHandler );
    void Tra_0164_0173( TsmHandler& oHandler );
    void Tra_0164_0174( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 162:
        switch ( Command )
        {
        case 19:
          return TsmProspect::OK;
        case 20:
          return TsmProspect::OK;
        case 21:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 176:
        Tra_0164_0176( oHandler );
        break;
      case 175:
        Tra_0164_0175( oHandler );
        break;
      case 173:
        Tra_0164_0173( oHandler );
        break;
      case 174:
        Tra_0164_0174( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm )
  class Fsm_0161_0163 : public TsmFsm
  {
  private:
    Reg_0163_0164* oReg_0163_0164; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >)

  public:
    Fsm_0161_0163( TsmBase* oParent )
    {
      TsmName = "FanServerPsm";
      TsmParent = oParent;
      oReg_0163_0164 = new Reg_0163_0164( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0163_0164;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanServer )
  class Cla_0160_0161 : public TsmProtocolClass
  {
  private:
    Fsm_0161_0163* oFsm_0161_0163; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm )
    TsmIPort_IFan* TsmPI__Port; // ( Xmi > Data > Protocols > FanProtocol > FanServer > Port )
    TsmPSPort* mPSMessager;

  public:
    Cla_0160_0161( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0161_0163 = new Fsm_0161_0163( this );
      TsmPI__Port = new TsmIPort_IFan( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0161_0163;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > FanProtocol > FanServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0161_0163->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0160_0161()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> InitialState )
  class Ini_0180_0181 : public TsmPseudo
  {
  public:
    Ini_0180_0181( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 192, "( FanClientPsm >> InitialState ) => ( FanClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 192: // UP: ( FanClientPsm >> InitialState ) => ( FanClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> Low )
  class Lea_0183_0184 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0183_0184( TsmBase* oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 186, "( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0183_0187( TsmHandler& oHandler );
    void Tra_0180_0189( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 186:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 186: // UP: ( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 187:
        Tra_0183_0187( oHandler );
        break;
      case 189:
        Tra_0180_0189( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> High )
  class Lea_0183_0185 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0183_0185( TsmBase* oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 187, "( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0183_0186( TsmHandler& oHandler );
    void Tra_0180_0190( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 187:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 186:
        Tra_0183_0186( oHandler );
        break;
      case 187: // UP: ( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 190:
        Tra_0180_0190( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >)
  class Reg_0182_0183 : public TsmRegion
  {
  private:
    Lea_0183_0184* oLea_0183_0184; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> Low )
    Lea_0183_0185* oLea_0183_0185; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> High )

  public:
    Reg_0182_0183( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0183_0184 = new Lea_0183_0184( this );
      oLea_0183_0185 = new Lea_0183_0185( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oLea_0183_0184;
      mStates[ 1 ] = oLea_0183_0185;
    }

    void Tra_0183_0186( TsmHandler& oHandler );
    void Tra_0183_0187( TsmHandler& oHandler );
    void Tra_0180_0189( TsmHandler& oHandler );
    void Tra_0180_0190( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 186:
          return TsmProspect::OK;
        case 187:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 186:
        Tra_0183_0186( oHandler );
        break;
      case 187:
        Tra_0183_0187( oHandler );
        break;
      case 189:
        Tra_0180_0189( oHandler );
        break;
      case 190:
        Tra_0180_0190( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy )
  class Com_0180_0182 : public TsmCompound
  {
  private:
    static const int aNatives[1];
    Reg_0182_0183* oReg_0182_0183; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >)

  public:
    Com_0180_0182( TsmBase* oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_0182_0183 = new Reg_0182_0183( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0182_0183;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 191, "( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )" );
    }

    void Tra_0180_0189( TsmHandler& oHandler );
    void Tra_0180_0190( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 191:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 191: // UP: ( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 189:
        Tra_0180_0189( oHandler );
        break;
      case 190:
        Tra_0180_0190( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Idle )
  class Lea_0180_0188 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0180_0188( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 189, "( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )" );
      mTransitions[ 1 ] = new TsmTransition( 190, "( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )" );
    }

    void Tra_0180_0192( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0180_0191( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 189:
          return TsmProspect::OK;
        case 190:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 192:
        Tra_0180_0192( oHandler );
        break;
      case 191:
        Tra_0180_0191( oHandler );
        break;
      case 189: // UP: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 190: // UP: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >)
  class Reg_0179_0180 : public TsmRegion
  {
  private:
    Ini_0180_0181* oIni_0180_0181; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> InitialState )
    Com_0180_0182* oCom_0180_0182; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy )
    Lea_0180_0188* oLea_0180_0188; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Idle )

  public:
    Reg_0179_0180( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0180_0181 = new Ini_0180_0181( this );
      oCom_0180_0182 = new Com_0180_0182( this );
      oLea_0180_0188 = new Lea_0180_0188( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0180_0181;
      mStates[ 1 ] = oCom_0180_0182;
      mStates[ 2 ] = oLea_0180_0188;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0180_0192( TsmHandler& oHandler );
    void Tra_0180_0191( TsmHandler& oHandler );
    void Tra_0180_0189( TsmHandler& oHandler );
    void Tra_0180_0190( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 191:
          return TsmProspect::OK;
        case 186:
          return TsmProspect::OK;
        case 187:
          return TsmProspect::OK;
        case 189:
          return TsmProspect::OK;
        case 190:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 192:
        Tra_0180_0192( oHandler );
        break;
      case 191:
        Tra_0180_0191( oHandler );
        break;
      case 189:
        Tra_0180_0189( oHandler );
        break;
      case 190:
        Tra_0180_0190( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm )
  class Fsm_0177_0179 : public TsmFsm
  {
  private:
    Reg_0179_0180* oReg_0179_0180; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >)

  public:
    Fsm_0177_0179( TsmBase* oParent )
    {
      TsmName = "FanClientPsm";
      TsmParent = oParent;
      oReg_0179_0180 = new Reg_0179_0180( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0179_0180;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > FanProtocol > FanClient )
  class Cla_0160_0177 : public TsmProtocolClass
  {
  private:
    Fsm_0177_0179* oFsm_0177_0179; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm )
    TsmIPort_IFan* Port; // ( Xmi > Data > Protocols > FanProtocol > FanClient > Port )

  public:
    Cla_0160_0177( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0177_0179 = new Fsm_0177_0179( this );
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0177_0179;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IFan*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > FanProtocol > FanClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0177_0179->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1058( TsmHandler& oHandler );
    void Function_1059( TsmHandler& oHandler );
    void Function_1060( TsmHandler& oHandler );
    void Function_1061( TsmHandler& oHandler );
    void Function_1062( TsmHandler& oHandler );
    void TsmPrepare( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > FanProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > FanProtocol )
  class Pac_0007_0160 : public TsmPackage
  {
  public:
    Pac_0007_0160( TsmBase* oParent )
    {
      TsmName = "FanProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmClient )
  class Cla_0193_0194 : public TsmProtocolClass
  {
  private:
    TsmIPort_INvm* Port; // ( Xmi > Data > Protocols > NvmProtocol > NvmClient > Port )

  public:
    Cla_0193_0194( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      mNrFsms = 0;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_INvm*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > NvmProtocol > NvmClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      SnapCall = "";
      SnapState.clear();
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> InitialState )
  class Ini_0199_0200 : public TsmPseudo
  {
  public:
    Ini_0199_0200( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 204, "( NvmServerFsm >> InitialState ) => ( NvmServerFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 204: // UP: ( NvmServerFsm >> InitialState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
  class Cho_0199_0201 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0199_0201( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 206, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 207, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0199_0205( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 206: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 207: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 205:
        Tra_0199_0205( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
  class Cho_0199_0202 : public TsmPseudo
  {
  private:
    int MaxNrChoices;

  public:
    Cho_0199_0202( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      MaxNrChoices = 2;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 210, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 211, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0199_0209( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 210: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 211: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 209:
        Tra_0199_0209( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> Idle )
  class Lea_0199_0203 : public TsmLeaf
  {
  public:
    Lea_0199_0203( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 209, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState ) : GetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 212, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> Idle ) : SetTarget" );
      mTransitions[ 2 ] = new TsmTransition( 205, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState ) : GetFanLevel" );
      mTransitions[ 3 ] = new TsmTransition( 208, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> Idle ) : SetFanLevel" );
    }

    void Tra_0199_0204( TsmHandler& oHandler );
    void Tra_0199_0206( TsmHandler& oHandler );
    void Tra_0199_0207( TsmHandler& oHandler );
    void Tra_0199_0210( TsmHandler& oHandler );
    void Tra_0199_0211( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Port___GetTarget( TsmHandler& oHandler );
    void Tra_0199_0212( TsmHandler& oHandler );
    void Port___SetTarget( int Target, TsmHandler& oHandler );
    void Port___GetFanLevel( TsmHandler& oHandler );
    void Tra_0199_0208( TsmHandler& oHandler );
    void Port___SetFanLevel( FanLevel Level, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 197:
        switch ( Command )
        {
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        case 25:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 204:
        Tra_0199_0204( oHandler );
        break;
      case 206:
        Tra_0199_0206( oHandler );
        break;
      case 207:
        Tra_0199_0207( oHandler );
        break;
      case 210:
        Tra_0199_0210( oHandler );
        break;
      case 211:
        Tra_0199_0211( oHandler );
        break;
      case 209: // UP: ( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState )
        bHigher = true;
        break;
      case 212:
        Tra_0199_0212( oHandler );
        break;
      case 205: // UP: ( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState )
        bHigher = true;
        break;
      case 208:
        Tra_0199_0208( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >)
  class Reg_0198_0199 : public TsmRegion
  {
  private:
    Ini_0199_0200* oIni_0199_0200; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> InitialState )
    Cho_0199_0201* oCho_0199_0201; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
    Cho_0199_0202* oCho_0199_0202; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
    Lea_0199_0203* oLea_0199_0203; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> Idle )

  public:
    Reg_0198_0199( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0199_0200 = new Ini_0199_0200( this );
      oCho_0199_0201 = new Cho_0199_0201( this );
      oCho_0199_0202 = new Cho_0199_0202( this );
      oLea_0199_0203 = new Lea_0199_0203( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0199_0200;
      mStates[ 1 ] = oCho_0199_0201;
      mStates[ 2 ] = oCho_0199_0202;
      mStates[ 3 ] = oLea_0199_0203;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0199_0204( TsmHandler& oHandler );
    void Tra_0199_0206( TsmHandler& oHandler );
    void Tra_0199_0207( TsmHandler& oHandler );
    void Tra_0199_0210( TsmHandler& oHandler );
    void Tra_0199_0211( TsmHandler& oHandler );
    void Tra_0199_0209( TsmHandler& oHandler );
    void Tra_0199_0205( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 197:
        switch ( Command )
        {
        case 22:
          return TsmProspect::OK;
        case 23:
          return TsmProspect::OK;
        case 24:
          return TsmProspect::OK;
        case 25:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 204:
        Tra_0199_0204( oHandler );
        break;
      case 206:
        Tra_0199_0206( oHandler );
        break;
      case 207:
        Tra_0199_0207( oHandler );
        break;
      case 210:
        Tra_0199_0210( oHandler );
        break;
      case 211:
        Tra_0199_0211( oHandler );
        break;
      case 209:
        Tra_0199_0209( oHandler );
        break;
      case 205:
        Tra_0199_0205( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm )
  class Fsm_0196_0198 : public TsmFsm
  {
  private:
    Reg_0198_0199* oReg_0198_0199; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >)

  public:
    Fsm_0196_0198( TsmBase* oParent )
    {
      TsmName = "NvmServerFsm";
      TsmParent = oParent;
      oReg_0198_0199 = new Reg_0198_0199( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0198_0199;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer )
  class Cla_0193_0196 : public TsmProtocolClass
  {
  private:
    Fsm_0196_0198* oFsm_0196_0198; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm )
    TsmIPort_INvm* TsmPI__Port; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > Port )
    TsmPSPort* mPSMessager;

  public:
    Cla_0193_0196( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0196_0198 = new Fsm_0196_0198( this );
      TsmPI__Port = new TsmIPort_INvm( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0196_0198;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > NvmProtocol > NvmServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0196_0198->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    FanLevel Function_1010();
    void Function_1011( TsmHandler& oHandler );
    FanLevel Function_1012();
    void Function_1013( TsmHandler& oHandler );
    int Function_1014();
    void Function_1015( TsmHandler& oHandler );
    int Function_1016();
    void Function_1017( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0193_0196()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > NvmProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > NvmProtocol )
  class Pac_0007_0193 : public TsmPackage
  {
  public:
    Pac_0007_0193( TsmBase* oParent )
    {
      TsmName = "NvmProtocol";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  class Pac_0006_0007 : public TsmPackage
  {
  public:
    Pac_0006_0007( TsmBase* oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> InitialState )
  class Ini_0239_0240 : public TsmPseudo
  {
  public:
    Ini_0239_0240( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 274, "( AircoFsm >> InitialState ) => ( AircoFsm >> Standby )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 274: // UP: ( AircoFsm >> InitialState ) => ( AircoFsm >> Standby )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > InitialState )
  class Ini_0242_0243 : public TsmPseudo
  {
  public:
    Ini_0242_0243( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 250, "( AircoFsm >> Active > Cooler > InitialState ) => ( AircoFsm >> Active > Cooler > Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 250: // UP: ( AircoFsm >> Active > Cooler > InitialState ) => ( AircoFsm >> Active > Cooler > Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > FinalState )
  class Fin_0242_0244 : public TsmFinal
  {
  public:
    Fin_0242_0244( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0242_0254( TsmHandler& oHandler );
    void Tra_0242_0255( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 254:
        Tra_0242_0254( oHandler );
        break;
      case 255:
        Tra_0242_0255( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )
  class Con_0245_0246 : public TsmState
  {
  public:
    Con_0245_0246( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 253, "( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 253: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )
  class Con_0245_0247 : public TsmState
  {
  public:
    Con_0245_0247( TsmBase* oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 254, "( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 254: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> InitialState )
  class Ini_0278_0279 : public TsmPseudo
  {
  public:
    Ini_0278_0279( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 318, "( AircoFsm > CoolingSubFsm >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 318: // UP: ( AircoFsm > CoolingSubFsm >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> InitialState )
  class Ini_0326_0327 : public TsmPseudo
  {
  public:
    Ini_0326_0327( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 330, "( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 330: // UP: ( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> FinalState )
  class Fin_0326_0328 : public TsmFinal
  {
  public:
    Fin_0326_0328( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0326_0333( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 333:
        Tra_0326_0333( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> Wait )
  class Lea_0326_0329 : public TsmLeaf
  {
  public:
    Lea_0326_0329( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition*[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 331, "( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> Wait ) : rp_sensor->CbAbove" );
      mTransitions[ 1 ] = new TsmTransition( 332, "( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> Wait ) : rp_sensor->CbBelow" );
      mTransitions[ 2 ] = new TsmTransition( 333, "( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> FinalState ) : rp_sensor->CbStopped" );
    }

    void Tra_0326_0330( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0326_0331( TsmHandler& oHandler );
    void rp_sensor___CbAbove( TsmHandler& oHandler );
    void Tra_0326_0332( TsmHandler& oHandler );
    void rp_sensor___CbBelow( TsmHandler& oHandler );
    void rp_sensor___CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 330:
        Tra_0326_0330( oHandler );
        break;
      case 331:
        Tra_0326_0331( oHandler );
        break;
      case 332:
        Tra_0326_0332( oHandler );
        break;
      case 333: // UP: ( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> FinalState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >)
  class Reg_0325_0326 : public TsmRegion
  {
  private:
    Ini_0326_0327* oIni_0326_0327; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> InitialState )
    Fin_0326_0328* oFin_0326_0328; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> FinalState )
    Lea_0326_0329* oLea_0326_0329; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> Wait )

  public:
    Reg_0325_0326( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0326_0327 = new Ini_0326_0327( this );
      oFin_0326_0328 = new Fin_0326_0328( this );
      oLea_0326_0329 = new Lea_0326_0329( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0326_0327;
      mStates[ 1 ] = oFin_0326_0328;
      mStates[ 2 ] = oLea_0326_0329;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0326_0330( TsmHandler& oHandler );
    void Tra_0326_0333( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 330:
        Tra_0326_0330( oHandler );
        break;
      case 333:
        Tra_0326_0333( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm )
  class Fsm_0238_0325 : public TsmFsm
  {
  private:
    Reg_0325_0326* oReg_0325_0326; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >)

  public:
    Fsm_0238_0325( TsmBase* oParent )
    {
      TsmName = "StoppingSubFsm";
      TsmParent = oParent;
      oReg_0325_0326 = new Reg_0325_0326( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0325_0326;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> OffStopping )
  class Sub_0278_0280 : public TsmSubFsm
  {
  public:
    Sub_0278_0280( TsmBase* oParent )
    {
      TsmName = "OffStopping";
      TsmParent = oParent;
      oFsm = new Fsm_0238_0325( this ); // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm )
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 320, "( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )" );
    }

    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0278_0319( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 320: // UP: ( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 319:
        Tra_0278_0319( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Stopping )
  class Sub_0278_0281 : public TsmSubFsm
  {
  public:
    Sub_0278_0281( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      oFsm = new Fsm_0238_0325( this ); // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm )
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 322, "( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )" );
    }

    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0278_0321( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 322: // UP: ( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 321:
        Tra_0278_0321( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> InitialState )
  class Ini_0283_0284 : public TsmPseudo
  {
  public:
    Ini_0283_0284( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 313, "( AircoFsm > CoolingSubFsm >> Composite >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 313: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> JuncState )
  class Jun_0283_0285 : public TsmPseudo
  {
  public:
    Jun_0283_0285( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 314, "( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )" );
    }

    void Tra_0283_0313( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0283_0316( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 313:
        Tra_0283_0313( oHandler );
        break;
      case 314: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
        bHigher = true;
        break;
      case 316:
        Tra_0283_0316( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
  class Cho_0283_0286 : public TsmPseudo
  {
  public:
    Cho_0283_0286( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 315, "( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )" );
      mTransitions[ 1 ] = new TsmTransition( 317, "( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )" );
    }

    void Tra_0283_0314( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 314:
        Tra_0283_0314( oHandler );
        break;
      case 315: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        bHigher = true;
        break;
      case 317: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState )
  class Ini_0288_0289 : public TsmPseudo
  {
  public:
    Ini_0288_0289( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 293, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 293: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
  class Fin_0288_0290 : public TsmFinal
  {
  public:
    Fin_0288_0290( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0288_0295( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 295:
        Tra_0288_0295( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
  class Lea_0288_0291 : public TsmLeaf
  {
  public:
    Lea_0288_0291( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 294, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) : pp_airco->SetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 297, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling ) : rp_sensor->CbAbove" );
    }

    void Tra_0288_0293( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_airco___SetTarget( int Target, TsmHandler& oHandler );
    void rp_sensor___CbAbove( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 293:
        Tra_0288_0293( oHandler );
        break;
      case 294: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
        bHigher = true;
        break;
      case 297: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
  class Lea_0288_0292 : public TsmLeaf
  {
  public:
    Lea_0288_0292( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 296, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) : rp_sensor->CbAbove" );
      mTransitions[ 1 ] = new TsmTransition( 295, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState ) : rp_sensor->CbStopped" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0288_0294( TsmHandler& oHandler );
    void Tra_0288_0296( TsmHandler& oHandler );
    void rp_sensor___CbAbove( TsmHandler& oHandler );
    void rp_sensor___CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 294:
        Tra_0288_0294( oHandler );
        break;
      case 296:
        Tra_0288_0296( oHandler );
        break;
      case 295: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >)
  class Reg_0287_0288 : public TsmRegion
  {
  private:
    Ini_0288_0289* oIni_0288_0289; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState )
    Fin_0288_0290* oFin_0288_0290; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
    Lea_0288_0291* oLea_0288_0291; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
    Lea_0288_0292* oLea_0288_0292; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )

  public:
    Reg_0287_0288( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0288_0289 = new Ini_0288_0289( this );
      oFin_0288_0290 = new Fin_0288_0290( this );
      oLea_0288_0291 = new Lea_0288_0291( this );
      oLea_0288_0292 = new Lea_0288_0292( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0288_0289;
      mStates[ 1 ] = oFin_0288_0290;
      mStates[ 2 ] = oLea_0288_0291;
      mStates[ 3 ] = oLea_0288_0292;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0288_0293( TsmHandler& oHandler );
    void Tra_0288_0294( TsmHandler& oHandler );
    void Tra_0288_0295( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 293:
        Tra_0288_0293( oHandler );
        break;
      case 294:
        Tra_0288_0294( oHandler );
        break;
      case 297: // Up: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        mCurrentState = 0;
        bHigher = true;
        break;
      case 295:
        Tra_0288_0295( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing )
  class Com_0283_0287 : public TsmCompound
  {
  private:
    Reg_0287_0288* oReg_0287_0288; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >)

  public:
    Com_0283_0287( TsmBase* oParent )
    {
      TsmName = "Sensing";
      TsmParent = oParent;
      oReg_0287_0288 = new Reg_0287_0288( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0287_0288;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 316, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )" );
    }

    void Tra_0283_0315( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0299_0312( TsmHandler& oHandler );
    void Tra_0299_0311( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 315:
        Tra_0283_0315( oHandler );
        break;
      case 316: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 312:
        Tra_0299_0312( oHandler );
        break;
      case 297: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 311:
        Tra_0299_0311( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState )
  class Ini_0299_0300 : public TsmPseudo
  {
  public:
    Ini_0299_0300( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 306, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 306: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
  class Jun_0299_0301 : public TsmPseudo
  {
  public:
    Jun_0299_0301( TsmBase* oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 305, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )" );
    }

    void Tra_0299_0306( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0299_0310( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 306:
        Tra_0299_0306( oHandler );
        break;
      case 305: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
        bHigher = true;
        break;
      case 310:
        Tra_0299_0310( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
  class Cho_0299_0302 : public TsmPseudo
  {
  public:
    Cho_0299_0302( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 312, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )" );
      mTransitions[ 1 ] = new TsmTransition( 310, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0299_0309( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 312: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        bHigher = true;
        break;
      case 310: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
        bHigher = true;
        break;
      case 309:
        Tra_0299_0309( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
  class Lea_0299_0303 : public TsmLeaf
  {
  public:
    Lea_0299_0303( TsmBase* oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 307, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) : pp_airco->SetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 311, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) : rp_sensor->CbBelow" );
    }

    void Tra_0299_0305( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_airco___SetTarget( int Target, TsmHandler& oHandler );
    void rp_sensor___CbBelow( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 11:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 305:
        Tra_0299_0305( oHandler );
        break;
      case 307: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
        bHigher = true;
        break;
      case 311: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
  class Lea_0299_0304 : public TsmLeaf
  {
  public:
    Lea_0299_0304( TsmBase* oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 308, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) : rp_sensor->CbBelow" );
      mTransitions[ 1 ] = new TsmTransition( 309, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) : rp_sensor->CbStopped" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0299_0307( TsmHandler& oHandler );
    void Tra_0299_0308( TsmHandler& oHandler );
    void rp_sensor___CbBelow( TsmHandler& oHandler );
    void rp_sensor___CbStopped( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 237:
        switch ( Command )
        {
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 307:
        Tra_0299_0307( oHandler );
        break;
      case 308:
        Tra_0299_0308( oHandler );
        break;
      case 309: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >)
  class Reg_0298_0299 : public TsmRegion
  {
  private:
    Ini_0299_0300* oIni_0299_0300; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState )
    Jun_0299_0301* oJun_0299_0301; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
    Cho_0299_0302* oCho_0299_0302; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
    Lea_0299_0303* oLea_0299_0303; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
    Lea_0299_0304* oLea_0299_0304; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )

  public:
    Reg_0298_0299( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0299_0300 = new Ini_0299_0300( this );
      oJun_0299_0301 = new Jun_0299_0301( this );
      oCho_0299_0302 = new Cho_0299_0302( this );
      oLea_0299_0303 = new Lea_0299_0303( this );
      oLea_0299_0304 = new Lea_0299_0304( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0299_0300;
      mStates[ 1 ] = oJun_0299_0301;
      mStates[ 2 ] = oCho_0299_0302;
      mStates[ 3 ] = oLea_0299_0303;
      mStates[ 4 ] = oLea_0299_0304;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0299_0306( TsmHandler& oHandler );
    void Tra_0299_0305( TsmHandler& oHandler );
    void Tra_0299_0310( TsmHandler& oHandler );
    void Tra_0299_0307( TsmHandler& oHandler );
    void Tra_0299_0309( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 306:
        Tra_0299_0306( oHandler );
        break;
      case 305:
        Tra_0299_0305( oHandler );
        break;
      case 312: // Up: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        mCurrentState = 0;
        bHigher = true;
        break;
      case 310:
        Tra_0299_0310( oHandler );
        break;
      case 307:
        Tra_0299_0307( oHandler );
        break;
      case 311: // Up: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        mCurrentState = 0;
        bHigher = true;
        break;
      case 309:
        Tra_0299_0309( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling )
  class Com_0283_0298 : public TsmCompound
  {
  private:
    Reg_0298_0299* oReg_0298_0299; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >)

  public:
    Com_0283_0298( TsmBase* oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      oReg_0298_0299 = new Reg_0298_0299( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0298_0299;
      mNrTransitions = 0;
    }

    void Tra_0283_0317( TsmHandler& oHandler );
    void Tra_0288_0297( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 317:
        Tra_0283_0317( oHandler );
        break;
      case 312: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 297:
        Tra_0288_0297( oHandler );
        break;
      case 311: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >)
  class Reg_0282_0283 : public TsmRegion
  {
  private:
    Ini_0283_0284* oIni_0283_0284; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> InitialState )
    Jun_0283_0285* oJun_0283_0285; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> JuncState )
    Cho_0283_0286* oCho_0283_0286; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
    Com_0283_0287* oCom_0283_0287; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing )
    Com_0283_0298* oCom_0283_0298; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling )

  public:
    Reg_0282_0283( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0283_0284 = new Ini_0283_0284( this );
      oJun_0283_0285 = new Jun_0283_0285( this );
      oCho_0283_0286 = new Cho_0283_0286( this );
      oCom_0283_0287 = new Com_0283_0287( this );
      oCom_0283_0298 = new Com_0283_0298( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0283_0284;
      mStates[ 1 ] = oJun_0283_0285;
      mStates[ 2 ] = oCho_0283_0286;
      mStates[ 3 ] = oCom_0283_0287;
      mStates[ 4 ] = oCom_0283_0298;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0283_0313( TsmHandler& oHandler );
    void Tra_0283_0314( TsmHandler& oHandler );
    void Tra_0283_0315( TsmHandler& oHandler );
    void Tra_0283_0317( TsmHandler& oHandler );
    void Tra_0283_0316( TsmHandler& oHandler );
    void Tra_0299_0312( TsmHandler& oHandler );
    void Tra_0288_0297( TsmHandler& oHandler );
    void Tra_0299_0311( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 5:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 313:
        Tra_0283_0313( oHandler );
        break;
      case 314:
        Tra_0283_0314( oHandler );
        break;
      case 315:
        Tra_0283_0315( oHandler );
        break;
      case 317:
        Tra_0283_0317( oHandler );
        break;
      case 316:
        Tra_0283_0316( oHandler );
        break;
      case 312:
        Tra_0299_0312( oHandler );
        break;
      case 297:
        Tra_0288_0297( oHandler );
        break;
      case 311:
        Tra_0299_0311( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite )
  class Com_0278_0282 : public TsmCompound
  {
  private:
    Reg_0282_0283* oReg_0282_0283; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >)

  public:
    Com_0278_0282( TsmBase* oParent )
    {
      TsmName = "Composite";
      TsmParent = oParent;
      oReg_0282_0283 = new Reg_0282_0283( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0282_0283;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 319, "( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> OffStopping ) : pp_airco->Off" );
      mTransitions[ 1 ] = new TsmTransition( 321, "( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> Stopping ) : pp_airco->Stop" );
    }

    void Tra_0278_0318( TsmHandler& oHandler );
    void pp_airco___Off( TsmHandler& oHandler );
    void pp_airco___Stop( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 318:
        Tra_0278_0318( oHandler );
        break;
      case 319: // UP: ( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> OffStopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 321: // UP: ( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >)
  class Reg_0277_0278 : public TsmRegion
  {
  private:
    Ini_0278_0279* oIni_0278_0279; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> InitialState )
    Sub_0278_0280* oSub_0278_0280; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> OffStopping )
    Sub_0278_0281* oSub_0278_0281; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Stopping )
    Com_0278_0282* oCom_0278_0282; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite )

  public:
    Reg_0277_0278( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0278_0279 = new Ini_0278_0279( this );
      oSub_0278_0280 = new Sub_0278_0280( this );
      oSub_0278_0281 = new Sub_0278_0281( this );
      oCom_0278_0282 = new Com_0278_0282( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0278_0279;
      mStates[ 1 ] = oSub_0278_0280;
      mStates[ 2 ] = oSub_0278_0281;
      mStates[ 3 ] = oCom_0278_0282;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0278_0318( TsmHandler& oHandler );
    void Tra_0278_0319( TsmHandler& oHandler );
    void Tra_0278_0321( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 318:
        Tra_0278_0318( oHandler );
        break;
      case 320: // Up: ( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )
        mCurrentState = 0;
        bHigher = true;
        break;
      case 322: // Up: ( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )
        mCurrentState = 0;
        bHigher = true;
        break;
      case 319:
        Tra_0278_0319( oHandler );
        break;
      case 321:
        Tra_0278_0321( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm )
  class Fsm_0238_0277 : public TsmFsm
  {
  private:
    Reg_0277_0278* oReg_0277_0278; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >)

  public:
    Fsm_0238_0277( TsmBase* oParent )
    {
      TsmName = "CoolingSubFsm";
      TsmParent = oParent;
      oReg_0277_0278 = new Reg_0277_0278( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0277_0278;
      mNrTransitions = 0;
    }

    void Tra_0278_0320( TsmHandler& oHandler );
    void Tra_0278_0322( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 320:
        Tra_0278_0320( oHandler );
        break;
      case 322:
        Tra_0278_0322( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling )
  class Sub_0242_0245 : public TsmSubFsm
  {
  private:
    Con_0245_0246* oCon_0245_0246; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )
    Con_0245_0247* oCon_0245_0247; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )

  public:
    Sub_0242_0245( TsmBase* oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      oFsm = new Fsm_0238_0277( this ); // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm )
      oCon_0245_0246 = new Con_0245_0246( this );
      oCon_0245_0247 = new Con_0245_0247( this );
      mNrTransitions = 0;
    }

    void Tra_0242_0252( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    ~Sub_0242_0245()
    {
      delete oCon_0245_0246;
      delete oCon_0245_0247;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 324: // UmlConnExit(Ref)
        oCon_0245_0246->Initial( oHandler );
        break;
      case 323: // UmlConnExit(Ref)
        oCon_0245_0247->Initial( oHandler );
        break;
      case 253: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 254: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 252:
        Tra_0242_0252( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Idle )
  class Lea_0242_0248 : public TsmLeaf
  {
  public:
    Lea_0242_0248( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition*[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 255, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > FinalState ) : pp_airco->Off" );
      mTransitions[ 1 ] = new TsmTransition( 249, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle ) : pp_airco->GetTarget" );
      mTransitions[ 2 ] = new TsmTransition( 251, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle ) : pp_airco->SetTarget" );
      mTransitions[ 3 ] = new TsmTransition( 252, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Cooling ) : pp_airco->Start" );
    }

    void Tra_0242_0250( TsmHandler& oHandler );
    void Tra_0242_0253( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_airco___Off( TsmHandler& oHandler );
    void Tra_0242_0249( TsmHandler& oHandler );
    void pp_airco___GetTarget( TsmHandler& oHandler );
    void Tra_0242_0251( TsmHandler& oHandler );
    void pp_airco___SetTarget( int Target, TsmHandler& oHandler );
    void pp_airco___Start( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 250:
        Tra_0242_0250( oHandler );
        break;
      case 253:
        Tra_0242_0253( oHandler );
        break;
      case 255: // UP: ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > FinalState )
        bHigher = true;
        break;
      case 249:
        Tra_0242_0249( oHandler );
        break;
      case 251:
        Tra_0242_0251( oHandler );
        break;
      case 252: // UP: ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Cooling )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler )
  class Reg_0241_0242 : public TsmRegion
  {
  private:
    Ini_0242_0243* oIni_0242_0243; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > InitialState )
    Fin_0242_0244* oFin_0242_0244; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > FinalState )
    Sub_0242_0245* oSub_0242_0245; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling )
    Lea_0242_0248* oLea_0242_0248; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Idle )

  public:
    Reg_0241_0242( TsmBase* oParent )
    {
      TsmName = "Cooler";
      TsmParent = oParent;
      oIni_0242_0243 = new Ini_0242_0243( this );
      oFin_0242_0244 = new Fin_0242_0244( this );
      oSub_0242_0245 = new Sub_0242_0245( this );
      oLea_0242_0248 = new Lea_0242_0248( this );
      mNrStates = 4;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0242_0243;
      mStates[ 1 ] = oFin_0242_0244;
      mStates[ 2 ] = oSub_0242_0245;
      mStates[ 3 ] = oLea_0242_0248;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0242_0250( TsmHandler& oHandler );
    void Tra_0242_0253( TsmHandler& oHandler );
    void Tra_0242_0254( TsmHandler& oHandler );
    void Tra_0242_0255( TsmHandler& oHandler );
    void Tra_0242_0252( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 250:
        Tra_0242_0250( oHandler );
        break;
      case 253:
        Tra_0242_0253( oHandler );
        break;
      case 254:
        Tra_0242_0254( oHandler );
        break;
      case 255:
        Tra_0242_0255( oHandler );
        break;
      case 252:
        Tra_0242_0252( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > InitialState )
  class Ini_0256_0257 : public TsmPseudo
  {
  public:
    Ini_0256_0257( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 267, "( AircoFsm >> Active > Fan > InitialState ) => ( AircoFsm >> Active > Fan > ReportLevel )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 267: // UP: ( AircoFsm >> Active > Fan > InitialState ) => ( AircoFsm >> Active > Fan > ReportLevel )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > FinalState )
  class Fin_0256_0258 : public TsmFinal
  {
  public:
    Fin_0256_0258( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0256_0268( TsmHandler& oHandler );
    void Tra_0256_0272( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 268:
        Tra_0256_0268( oHandler );
        break;
      case 272:
        Tra_0256_0272( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ChoiceState )
  class Cho_0256_0259 : public TsmPseudo
  {
  public:
    Cho_0256_0259( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 271, "( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )" );
      mTransitions[ 1 ] = new TsmTransition( 270, "( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0256_0269( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 271: // UP: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
        bHigher = true;
        break;
      case 270: // UP: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
        bHigher = true;
        break;
      case 269:
        Tra_0256_0269( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> Low )
  class Lea_0261_0262 : public TsmLeaf
  {
  public:
    Lea_0261_0262( TsmBase* oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 264, "( AircoFsm >> Active > Fan > Active >> Low ) => ( AircoFsm >> Active > Fan > Active >> High ) : pp_airco->FanHigh" );
    }

    void Tra_0256_0271( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0261_0265( TsmHandler& oHandler );
    void pp_airco___FanHigh( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 271:
        Tra_0256_0271( oHandler );
        break;
      case 265:
        Tra_0261_0265( oHandler );
        break;
      case 264: // UP: ( AircoFsm >> Active > Fan > Active >> Low ) => ( AircoFsm >> Active > Fan > Active >> High )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> High )
  class Lea_0261_0263 : public TsmLeaf
  {
  public:
    Lea_0261_0263( TsmBase* oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 265, "( AircoFsm >> Active > Fan > Active >> High ) => ( AircoFsm >> Active > Fan > Active >> Low ) : pp_airco->FanLow" );
    }

    void Tra_0256_0270( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_airco___FanLow( TsmHandler& oHandler );
    void Tra_0261_0264( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 270:
        Tra_0256_0270( oHandler );
        break;
      case 265: // UP: ( AircoFsm >> Active > Fan > Active >> High ) => ( AircoFsm >> Active > Fan > Active >> Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 264:
        Tra_0261_0264( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >)
  class Reg_0260_0261 : public TsmRegion
  {
  private:
    Lea_0261_0262* oLea_0261_0262; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> Low )
    Lea_0261_0263* oLea_0261_0263; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> High )

  public:
    Reg_0260_0261( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0261_0262 = new Lea_0261_0262( this );
      oLea_0261_0263 = new Lea_0261_0263( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oLea_0261_0262;
      mStates[ 1 ] = oLea_0261_0263;
    }

    void Tra_0256_0271( TsmHandler& oHandler );
    void Tra_0256_0270( TsmHandler& oHandler );
    void Tra_0261_0265( TsmHandler& oHandler );
    void Tra_0261_0264( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 271:
        Tra_0256_0271( oHandler );
        break;
      case 270:
        Tra_0256_0270( oHandler );
        break;
      case 265:
        Tra_0261_0265( oHandler );
        break;
      case 264:
        Tra_0261_0264( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active )
  class Com_0256_0260 : public TsmCompound
  {
  private:
    Reg_0260_0261* oReg_0260_0261; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >)

  public:
    Com_0256_0260( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0260_0261 = new Reg_0260_0261( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0260_0261;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 268, "( AircoFsm >> Active > Fan > Active ) => ( AircoFsm >> Active > Fan > FinalState ) : pp_airco->Off" );
    }

    void Tra_0256_0271( TsmHandler& oHandler );
    void Tra_0256_0270( TsmHandler& oHandler );
    void pp_airco___Off( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtMyExit( TsmHandler& oHandler );
    void ExecuteTriggerCompound( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 271:
        Tra_0256_0271( oHandler );
        break;
      case 270:
        Tra_0256_0270( oHandler );
        break;
      case 268: // UP: ( AircoFsm >> Active > Fan > Active ) => ( AircoFsm >> Active > Fan > FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ReportLevel )
  class Lea_0256_0266 : public TsmLeaf
  {
  public:
    Lea_0256_0266( TsmBase* oParent )
    {
      TsmName = "ReportLevel";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 272, "( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > FinalState ) : pp_airco->Off" );
      mTransitions[ 1 ] = new TsmTransition( 269, "( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > ChoiceState ) : pp_airco->GetLevel" );
    }

    void Tra_0256_0267( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_airco___Off( TsmHandler& oHandler );
    void pp_airco___GetLevel( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 267:
        Tra_0256_0267( oHandler );
        break;
      case 272: // UP: ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > FinalState )
        bHigher = true;
        break;
      case 269: // UP: ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > ChoiceState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan )
  class Reg_0241_0256 : public TsmRegion
  {
  private:
    Ini_0256_0257* oIni_0256_0257; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > InitialState )
    Fin_0256_0258* oFin_0256_0258; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > FinalState )
    Cho_0256_0259* oCho_0256_0259; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ChoiceState )
    Com_0256_0260* oCom_0256_0260; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active )
    Lea_0256_0266* oLea_0256_0266; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ReportLevel )

  public:
    Reg_0241_0256( TsmBase* oParent )
    {
      TsmName = "Fan";
      TsmParent = oParent;
      oIni_0256_0257 = new Ini_0256_0257( this );
      oFin_0256_0258 = new Fin_0256_0258( this );
      oCho_0256_0259 = new Cho_0256_0259( this );
      oCom_0256_0260 = new Com_0256_0260( this );
      oLea_0256_0266 = new Lea_0256_0266( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0256_0257;
      mStates[ 1 ] = oFin_0256_0258;
      mStates[ 2 ] = oCho_0256_0259;
      mStates[ 3 ] = oCom_0256_0260;
      mStates[ 4 ] = oLea_0256_0266;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0256_0267( TsmHandler& oHandler );
    void Tra_0256_0271( TsmHandler& oHandler );
    void Tra_0256_0270( TsmHandler& oHandler );
    void Tra_0256_0268( TsmHandler& oHandler );
    void Tra_0256_0272( TsmHandler& oHandler );
    void Tra_0256_0269( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 267:
        Tra_0256_0267( oHandler );
        break;
      case 271:
        Tra_0256_0271( oHandler );
        break;
      case 270:
        Tra_0256_0270( oHandler );
        break;
      case 268:
        Tra_0256_0268( oHandler );
        break;
      case 272:
        Tra_0256_0272( oHandler );
        break;
      case 269:
        Tra_0256_0269( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active )
  class Com_0239_0241 : public TsmCompound
  {
  private:
    Reg_0241_0242* oReg_0241_0242; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler )
    Reg_0241_0256* oReg_0241_0256; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan )

  public:
    Com_0239_0241( TsmBase* oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0241_0242 = new Reg_0241_0242( this );
      oReg_0241_0256 = new Reg_0241_0256( this );
      mNrRegions = 2;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0241_0242;
      mRegions[ 1 ] = oReg_0241_0256;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 276, "( AircoFsm >> Active ) => ( AircoFsm >> Standby )" );
    }

    void ExecuteTriggerless( TsmHandler& oHandler );
    void Tra_0239_0275( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 276: // UP: ( AircoFsm >> Active ) => ( AircoFsm >> Standby )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 275:
        Tra_0239_0275( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Standby )
  class Lea_0239_0273 : public TsmLeaf
  {
  public:
    Lea_0239_0273( TsmBase* oParent )
    {
      TsmName = "Standby";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 275, "( AircoFsm >> Standby ) => ( AircoFsm >> Active ) : pp_airco->On" );
    }

    void Tra_0239_0274( TsmHandler& oHandler );
    void Tra_0239_0276( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_airco___On( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 274:
        Tra_0239_0274( oHandler );
        break;
      case 276:
        Tra_0239_0276( oHandler );
        break;
      case 275: // UP: ( AircoFsm >> Standby ) => ( AircoFsm >> Active )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >)
  class Reg_0238_0239 : public TsmRegion
  {
  private:
    Ini_0239_0240* oIni_0239_0240; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> InitialState )
    Com_0239_0241* oCom_0239_0241; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active )
    Lea_0239_0273* oLea_0239_0273; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Standby )

  public:
    Reg_0238_0239( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0239_0240 = new Ini_0239_0240( this );
      oCom_0239_0241 = new Com_0239_0241( this );
      oLea_0239_0273 = new Lea_0239_0273( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0239_0240;
      mStates[ 1 ] = oCom_0239_0241;
      mStates[ 2 ] = oLea_0239_0273;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0239_0274( TsmHandler& oHandler );
    void Tra_0239_0276( TsmHandler& oHandler );
    void Tra_0239_0275( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 233:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        case 3:
          return TsmProspect::OK;
        case 4:
          return TsmProspect::OK;
        case 5:
          return TsmProspect::OK;
        case 6:
          return TsmProspect::OK;
        case 7:
          return TsmProspect::OK;
        case 8:
          return TsmProspect::OK;
        case 9:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 233
      case 237:
        switch ( Command )
        {
        case 10:
          return TsmProspect::OK;
        case 11:
          return TsmProspect::OK;
        case 12:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 274:
        Tra_0239_0274( oHandler );
        break;
      case 276:
        Tra_0239_0276( oHandler );
        break;
      case 275:
        Tra_0239_0275( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm )
  class Fsm_0232_0238 : public TsmFsm
  {
  private:
    Reg_0238_0239* oReg_0238_0239; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >)

  public:
    Fsm_0232_0238( TsmBase* oParent )
    {
      TsmName = "AircoFsm";
      TsmParent = oParent;
      oReg_0238_0239 = new Reg_0238_0239( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0238_0239;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass )
  class Cla_0230_0232 : public TsmClass
  {
  private:
    Fsm_0232_0238* oFsm_0232_0238; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm )
    TsmIPort_IAirco* TsmPI__pp_airco; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > pp_airco )
    TsmIPort_ICooler* rp_cooler; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_cooler )
    TsmIPort_IFan* rp_fan; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_fan )
    TsmIPort_INvm* rp_nvm; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_nvm )
    TsmIPort_ISensor* rp_sensor; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_sensor )
    TsmIPort_ICbSensor* TsmPI__rp_sensor; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_sensor )
    TsmPSPort* mPSMessager;
    TsmPCPort* mPCMessager;
    FanLevel Level;
    int MyTarget;
    double MyTemp;

  public:
    Cla_0230_0232( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0232_0238 = new Fsm_0232_0238( this );
      TsmPI__pp_airco = new TsmIPort_IAirco( this );
      TsmPI__rp_sensor = new TsmIPort_ICbSensor( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0232_0238;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_airco" )
      {
        return TsmPI__pp_airco;
      }
      if ( sPortName == "rp_sensor" )
      {
        return TsmPI__rp_sensor;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "rp_cooler" )
      {
        rp_cooler = static_cast<TsmIPort_ICooler*>(oProvidedInterface);
        rp_cooler->Source = this;
        return;
      }
      if ( sPortName == "rp_fan" )
      {
        rp_fan = static_cast<TsmIPort_IFan*>(oProvidedInterface);
        rp_fan->Source = this;
        return;
      }
      if ( sPortName == "rp_nvm" )
      {
        rp_nvm = static_cast<TsmIPort_INvm*>(oProvidedInterface);
        rp_nvm->Source = this;
        return;
      }
      if ( sPortName == "rp_sensor" )
      {
        rp_sensor = static_cast<TsmIPort_ISensor*>(oProvidedInterface);
        rp_sensor->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0232_0238->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1018( TsmHandler& oHandler );
    bool Guard_1019();
    FanLevel Function_1020();
    void Function_1021( TsmHandler& oHandler );
    FanLevel Function_1022();
    void Function_1023( TsmHandler& oHandler );
    void Function_1024( TsmHandler& oHandler );
    void Function_1025( TsmHandler& oHandler );
    void Function_1026( TsmHandler& oHandler );
    void Function_1027( TsmHandler& oHandler );
    void Function_1028( TsmHandler& oHandler );
    void Function_1029( TsmHandler& oHandler );
    void Function_1030( TsmHandler& oHandler );
    void Function_1031( TsmHandler& oHandler );
    void Function_1032( TsmHandler& oHandler );
    bool Guard_1033();
    void Function_1034( TsmHandler& oHandler );
    void Function_1035( TsmHandler& oHandler );
    void Function_1036( TsmHandler& oHandler );
    void Function_1037( TsmHandler& oHandler );
    bool Guard_1038();
    void Function_1039( TsmHandler& oHandler );
    void Function_1065( TsmHandler& oHandler );
    void Function_1066( TsmHandler& oHandler );
    int Function_1067();
    void Function_1068( TsmHandler& oHandler );
    void Function_1069( TsmHandler& oHandler );
    void Function_1070( TsmHandler& oHandler );
    void Function_1071( TsmHandler& oHandler );
    void Function_1072( TsmHandler& oHandler );
    void Function_1073( TsmHandler& oHandler );
    void Function_1074( TsmHandler& oHandler );
    void Function_1075( TsmHandler& oHandler );
    void Function_1076( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0230_0232()
    {
      delete TsmPI__pp_airco;
      delete TsmPI__rp_sensor;
      delete mPSMessager;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent )
  class Com_0229_0230 : public TsmAComponent
  {
  private:
    Cla_0230_0232* AircoInstance; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoInstance )
    TsmIPort_IAirco* TsmPI__d_pp_airco; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > d_pp_airco )
    TsmASPort* TsmMr__d_pp_airco;
    TsmIPort_ICbSensor* TsmPI__d_rp_sensor; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > d_rp_sensor )
    TsmACPort* TsmMr__d_rp_sensor;

  public:
    Com_0229_0230( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      AircoInstance = new Cla_0230_0232( this, "AircoInstance" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = AircoInstance;
      TsmPI__d_pp_airco = new TsmIPort_IAirco( this );
      TsmMr__d_pp_airco = new TsmASPort();
      TsmPI__d_rp_sensor = new TsmIPort_ICbSensor( this );
      TsmMr__d_rp_sensor = new TsmACPort();
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_airco" )
      {
        return TsmPI__d_pp_airco;
      }
      if ( sPortName == "d_rp_sensor" )
      {
        return TsmPI__d_rp_sensor;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_cooler" )
      {
        AircoInstance->SetRequiredInterface( "rp_cooler", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rp_fan" )
      {
        AircoInstance->SetRequiredInterface( "rp_fan", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rp_nvm" )
      {
        AircoInstance->SetRequiredInterface( "rp_nvm", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rp_sensor" )
      {
        AircoInstance->SetRequiredInterface( "rp_sensor", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent )";
      throw TsmException( s );
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );

    ~Com_0229_0230()
    {
      delete TsmPI__d_pp_airco;
      delete TsmMr__d_pp_airco;
      delete TsmPI__d_rp_sensor;
      delete TsmMr__d_rp_sensor;
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv > Fan )
  class Com_0214_0001 : public TsmPComponent
  {
  private:
    Cla_0160_0161* InsFanServer; // ( Xmi > Data > Protocols > FanProtocol > FanServer > InsFanServer )

  public:
    Com_0214_0001( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsFanServer = new Cla_0160_0161( this, "InsFanServer" );
      InsFanServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsFanServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_fan" )
      {
        return InsFanServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Fan )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv > Cooler )
  class Com_0214_0003 : public TsmPComponent
  {
  private:
    Cla_0139_0140* InsCoolerServer; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > InsCoolerServer )

  public:
    Com_0214_0003( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCoolerServer = new Cla_0139_0140( this, "InsCoolerServer" );
      InsCoolerServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCoolerServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_cooler" )
      {
        return InsCoolerServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Cooler )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv > Nvm )
  class Com_0214_0005 : public TsmPComponent
  {
  private:
    Cla_0193_0196* InsNvmServer; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > InsNvmServer )

  public:
    Com_0214_0005( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsNvmServer = new Cla_0193_0196( this, "InsNvmServer" );
      InsNvmServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsNvmServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_nvm" )
      {
        return InsNvmServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Nvm )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv > Ui )
  class Com_0214_0007 : public TsmPComponent
  {
  private:
    Cla_0008_0044* InsAircoClient; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > InsAircoClient )

  public:
    Com_0214_0007( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsAircoClient = new Cla_0008_0044( this, "InsAircoClient" );
      InsAircoClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsAircoClient;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "rp_airco" )
      {
        InsAircoClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Ui )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv > Sensor )
  class Com_0214_0009 : public TsmPComponent
  {
  private:
    Cla_0079_0107* InsSensorServer; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > InsSensorServer )

  public:
    Com_0214_0009( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsSensorServer = new Cla_0079_0107( this, "InsSensorServer" );
      InsSensorServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsSensorServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_sensor" )
      {
        return InsSensorServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Sensor )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_sensor" )
      {
        InsSensorServer->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Sensor )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv )
  class Com_0213_0214 : public TsmPComponent
  {
  private:
    Com_0229_0230* Airco; // ( Xmi > Data > Architecture > ExecEnv > Airco )
    Com_0214_0001* Fan; // ( Xmi > Data > Architecture > ExecEnv > Fan )
    Com_0214_0003* Cooler; // ( Xmi > Data > Architecture > ExecEnv > Cooler )
    Com_0214_0005* Nvm; // ( Xmi > Data > Architecture > ExecEnv > Nvm )
    Com_0214_0007* Ui; // ( Xmi > Data > Architecture > ExecEnv > Ui )
    Com_0214_0009* Sensor; // ( Xmi > Data > Architecture > ExecEnv > Sensor )

  public:
    Com_0213_0214( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Airco = new Com_0229_0230( this, "Airco" );
      Fan = new Com_0214_0001( this, "Fan" );
      Cooler = new Com_0214_0003( this, "Cooler" );
      Nvm = new Com_0214_0005( this, "Nvm" );
      Ui = new Com_0214_0007( this, "Ui" );
      Sensor = new Com_0214_0009( this, "Sensor" );
      mNrComponents = 6;
      mComponents = new TsmComponent*[ 6 ];
      mComponents[ 0 ] = Airco;
      mComponents[ 1 ] = Fan;
      mComponents[ 2 ] = Cooler;
      mComponents[ 3 ] = Nvm;
      mComponents[ 4 ] = Ui;
      mComponents[ 5 ] = Sensor;
    }

    void TsmConnect( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  class Pac_0213_0221 : public TsmPackage
  {
  public:
    Pac_0213_0221( TsmBase* oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  class Pac_0006_0213 : public TsmPackage
  {
  public:
    Pac_0006_0213( TsmBase* oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > CoolerComponent )
  class Com_0223_0224 : public TsmPComponent
  {
  public:
    Com_0223_0224( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > NvmComponent )
  class Com_0223_0225 : public TsmPComponent
  {
  public:
    Com_0223_0225( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > FanComponent )
  class Com_0223_0226 : public TsmPComponent
  {
  public:
    Com_0223_0226( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > SensorComponent )
  class Com_0223_0227 : public TsmPComponent
  {
  public:
    Com_0223_0227( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > UiComponent )
  class Com_0223_0228 : public TsmPComponent
  {
  public:
    Com_0223_0228( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Terminators )
   ********************************************************************/

   // ( Xmi > Data > Repository > Terminators )
  class Pac_0222_0223 : public TsmPackage
  {
  public:
    Pac_0222_0223( TsmBase* oParent )
    {
      TsmName = "Terminators";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > AircoPackage )
   ********************************************************************/

   // ( Xmi > Data > Repository > AircoPackage )
  class Pac_0222_0229 : public TsmPackage
  {
  public:
    Pac_0222_0229( TsmBase* oParent )
    {
      TsmName = "AircoPackage";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  class Pac_0006_0222 : public TsmPackage
  {
  public:
    Pac_0006_0222( TsmBase* oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TypeDefinitions )
   ********************************************************************/

   // ( Xmi > Data > TypeDefinitions )
  class Pac_0006_0334 : public TsmPackage
  {
  public:
    Pac_0006_0334( TsmBase* oParent )
    {
      TsmName = "TypeDefinitions";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  class Pac_0006_0335 : public TsmPackage
  {
  public:
    Pac_0006_0335( TsmBase* oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  };

   // ( Xmi )
  class TsmSystem : public TsmExecComponent
  {
  private:
    Com_0213_0214* ExecEnv; // ( Xmi > Data > Architecture > ExecEnv )

  public:
    TsmSystem( TsmBase* oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent*[ 1 ];
      ExecEnv = new Com_0213_0214( NULL, "ExecEnv" );
      mComponents[ 0 ] = ExecEnv;
    }
  };
}
#endif
